/*
 *	ff4decode.c
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "ff4file.h"
#include "ff4decode.h"

#define FILEPOS_TEXTDATA		0x2e2ee8
#define FILEPOS_TEXT_FLAG		(FILEPOS_TEXTDATA + 0x08)
#define FILEPOS_TEXT_SIZE		(FILEPOS_TEXTDATA + 0x09)
#define FILEPOS_TEXT_EOF		(FILEPOS_TEXTDATA + 0x0c)
#define FILEPOS_TEXT_ADDR		(FILEPOS_TEXTDATA + 0x10)
#define NUM_MSGID				6287
#define NUM_TEXTDATA			(NUM_MSGID * 2)
#define SIZEOF_OFFSETADDR		4

#define Z(chr)	#chr			/* FULLWIDTH */

/* եʥե󥿥 IV ɥХ󥹤ʸɽ */
static const char *tbl_charcode[25][64] =
{
	/* 0xc0 */
	{
		" ",  "\0", "", "", "", "", "", Z(!), "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", Z(?), "", "", " ",  "",
		"", "", "", "", "", "", "", "", "", Z(A), "", "", "", "", "", Z(I),
	},

	/* 0xc1 */
	{
		"", "", "", Z(O), "", "", "", Z(R), "", "", "", "", "", "", "", "",
		"", Z(N), "", "", "", "", Z(T), "", Z(S), Z(F), Z(B), Z(E), "", "", "", "",
		"", "", "", Z(U), "", "", "", "", "", Z(H), Z(M), "", "", Z(K), "", "",
		"", "", "", "", "", "", "P",  "", "", "", "", "", "", Z(C), Z(D), "",
	},

	/* 0xc2 */
	{
		"", "", "", "", "", "", "", "", "1",  "", Z(L), "", Z(G), "", "", "",
		"", "2",  "", "", Z(Y), "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "ʼ", "", "", "", "", "", "", "", "", "", "Ĺ", "", "Ϸ",
		"", "0",  "", "", "", "", "", "", "ƶ", "", "", "", "", "", "3",  "",
	},

	/* 0xc3 */
	{
		"", "", "", "", "", "", "", "", "", "", Z(W), "", "", "", "4",  "",
		"", "", "", "s",  Z(:), Z(Z), "e",  "̵", "", "", "", "", "", "", "", "",
		"ƻ", "", "n",  "3",  "", "", "o",  "d",  "t",  "u",  "", "", "", "ʪ", "", "",
		"", "", "", "", Z(Q), Z(V), "(",  ")",  "", "", "", Z(J), "", "", "", "",
	},

	/* 0xc4 */
	{
		"", "", "", "", "", "", "", "", "", "", "", "5",  "", "", "2",  "",
		"", "", "", "", "", "", "", "", "", "", "", "7",  "", "ˡ", "", "",
		"", "", "", "Ω", "", "", "", "̿", "ε", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "4",  "ï", "̲", "¼", "Į", "",
	},

	/* 0xc5 */
	{
		"", "", "ʹ", "", "ŷ", "", "̱", "9",  "", "", "", "", "6",  "8",  "", "",
		"", "", "", "", "", "ɬ", "1",  "", "", "", "", "", "", "", "", "",
		"", "", "", Z(n), "", Z(X), "", "", "̾", "", "", "ʬ", "ư", "", "ë", "",
		"", "", "", "", "0",  "", "", "ͷ", "", "", "", "", "ȯ", "ͦ", "", "å",
	},

	/* 0xc6 */
	{
		"", "", "", "", "", "", "", "̼", "", "", "", "", "", "", "h",  "",
		"5",  "", "9",  Z(e), "", "", "", "", "", "", "", "Ũ", "", "P",  "a",  "c",
		"r",  "", "", "", "", "", "", "", "­", "", "", "", "", "Ϣ", "ϩ", "",
		"", "6",  ".",  "", "", "-",  "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xc7 */
	{
		"", "+",  "", "", "", "", "", "ǰ", "", "", "ɽ", "", "", "", "ƨ", "",
		"", "", "Ʊ", "", "", "", "", "", "", "", "", "¸", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "Ƴ", "", "", "", Z(o),
		"", "", "̸", "", "", "", "", "", "", "ĥ", "", "", "", "", "", "",
	},

	/* 0xc8 */
	{
		"", "Ħ", "", "", "", "", "", "", "", "", "˺", "", "ˤ", "", "Ǧ", "",
		"̮", "H",  "8",  "ɤ", "", "", "", "", "©", "", "ͥ", "³", "", "", "", "",
		"", "", "ȴ", "", "«", "", "ι", "", "", Z(t), Z(y), "", "̣", "", "", "",
		"", "", "Ʈ", "", "Ǯ", "", "", "", "", "", "·", "", "", "", "", "",
	},

	/* 0xc9 */
	{
		"", "", "", "", "˾", "", "", "7",  "", "", "", "", "", "", "ή", "",
		"", "Ƥ", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "΢", "õ", "", "", "", "", "", "",
		"", "", "Ĵ", "", "", "̴", "", "", "", "¾", "", "", "", "", "", "",
	},

	/* 0xca */
	{
		"", "", "", "ǽ", "", "¤", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "¿", "", Z(m), Z(p), "", "",
		"", "", "", "", "", "", "", "", "", "", "", "α", "Ǥ", "", "ϴ", "",
		"ʸ", "", "", "ɹ", "", "", "", "", "ͧ", "", "", "", "", "", "", "",
	},

	/* 0xcb */
	{
		"", Z(%), "M",  "", "ê", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "ī", "", "", "ϫ", "", "", "", "", "", "Υ", "", "²", "",
		"", "", "", "", "", "", "", "", "", "", "", "Ŵ", "", "Ϳ", "", "",
		Z(i), "", "", "", "", "", "", "", "", "", "", "g",  "i",  "l",  "E",  "",
	},

	/* 0xcc */
	{
		"ǧ", "", "", "", "", "°", "", "", "", "", "", "", "", "˴", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "ã", "",
		"", "", "", "", "", "", "", "", "è", "", "", "", "", "̤", "", "Ķ",
		"", Z(a), Z(c), "", "", "Ȣ", "", "", "æ", "", "", "", "¦", "", "", "Ͽ",
	},

	/* 0xcd */
	{
		"ǯ", "\"", "", "", "", "", "", "", "á", "", "", "", "", "", "", "",
		"", "", "", "ʤ", "", "", "Ȳ", "", "Ψ", "ά", "", "ʢ", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "ñ", "", "", "", "", "",
		"", "", "ʿ", "", "", "", "", "", "", Z(g), Z(s), "A",  "", "ĺ", "¬", "",
	},

	/* 0xce */
	{

		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "b",  "f",
		"j",  "k",  "m",  "p",  "q",  "v",  "w",  "x",  "y",  "z",  "%",  ":",  "", "", "", "",
		"", "", "", "", "", "İ", "", "", "", "ί", "", "", "", "", "", "",
		"", "", "", "", "̳", "ȿ", "", "Φ", "", "", "", "", "", "", "", "",
	},

	/* 0xcf */
	{
		"", "", "", "", "", "", "", "", "", "", "", "Ƚ", "", "", "", "¡",
		"", "", "", "", "", "", "", "", "", "", "", "ʧ", "", "", "", "",
		"", "", "", "", "", "", Z(b), "", ",",  "", "", "", "", "", "ͣ", "ͳ",
		"", "", "", "", "", "", "", "", "", "Ƭ", "", "", "", "Ʒ", "", "",
	},

	/* 0xd0 */
	{
		"", "", "", "", "", "", "", "", "", "", "͢", "", "", "", "", "Ű",
		"", "", "", "Ⱦ", "", "", "", "", "Ļ", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "ľ", "", "", "", "", "",
		"", "", "", "˽", "", "", "", "", "", "ǳ", "", "ĩ", "", "", "", "",
	},

	/* 0xd1 */
	{
		"", "R",  "", "", "", "", "", "κ", "", "", "", "", "", "", "L",  "",
		"", "", "", "", "", "", "", "", "", Z(d), Z(f), Z(h), Z(j), Z(k), Z(l), Z(q),
		Z(r), Z(u), Z(v), Z(w), Z(x), Z(z), "T",  "Y",  "", "˫", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "¹", "", "", "", "",
	},

	/* 0xd2 */
	{
		"Ƨ", "", "", "U",  "S",  "F",  "", "", "", "", "", "", "", "λ", "", "",
		"", "", "", "", "", "", "", "", "", "", "Ǿ", "", "Ϫ", "ɴ", "ŵ", "",
		"", "", "", "", "Ͷ", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "ͩ", "", "", "", "", "", "", "", "ͪ",
	},

	/* 0xd3 */
	{
		"", "", "", "", "£", "ɱ", "Τ", "", "̯", "", "", "Ū", "", "", "", "",
		"", "Լ", "", "", "", "", "", "", "", "", "", "ϲ", "", "", "»", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "ķ", "", "¨", "ū",
		"", "", "", "", "", "ɸ", "", "", "", "", "", "ƴ", "", "", "", "",
	},

	/* 0xd4 */
	{
		"", "", "", "", "", "", "", "", "", "", "", "", "", "ͭ", "", "",
		"", "", "", "ü", "", "̩", "", "", "", "˦", "", "", "", "", "", "",
		"", "", "", "", "ʡ", "", "", "", "", "", "", "", "", "", "Ʋ", "",
		"", "", "", "", "", "", "Ǽ", "", "", "", "", "", "", "", "", "ô",
	},

	/* 0xd5 */
	{
		"", "", "", "", "û", "", "", "˭", "", "", "", "", "", "", "", "",
		"", "", "", "", "˻", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "Ʃ", "", "", "", "", "ʴ", "", "ű", "", "", "", "", "",
		"", "", "ͽ", "", "", "", "Ź", "", "", "®", "", ";", "ö", "", "", "",
	},

	/* 0xd6 */
	{
		"", "ť", "", "", "Ư", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "̥", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "",

		/* 򼨤楳(0xa20xbd) */
		"", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "",

		"", "",
	},

	/* 0xd7 */
	{
		" ",  "!",  "#",  "$",  "^",  "'",  "(",  ")",  "*",  "+",  "-",  "/",  ";",  "<",  "=",  ">",
		"?",  "@",  "B",  "C",  "D",  "G",  "I",  "J",  "K",  "N",  "O",  "Q",  "V",  "W",  "X",  "Z",
		"[",  "\\", "]",  "~",  "_",  "~",  "{",  "|",  "}",  "~",

		/* 楳 */
		"\0", "\n", "[D7 AC]",

		/* 饯̾򼨤楳(0xad0xb8) */
		"", "", "", "ǥ", "", "ƥ", "С", "",
		"ѥ", "ݥ", "å", "ա",

		/* ѹ򼨤楳(0xb90xbf) */
		"[D7 B9]", "[D7 BA]", "[D7 BB]", "[D7 BC]", "[D7 BD]", "[D7 BE]", "[D7 BF]",
	},

	/* 0xd8 */
	{
		/* Ԥ򼨤楳(0x81) */
		"[D8 80]",   "",

		/* 饰եå򼨤楳(0x820x8f) */
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",

		/* 楳 */
		"%s", "[D8 91]", "%d", "%d", "%d", "%s", "%d", "",
		"",   "[D8 99]", "[D8 9A]", "[D8 9B]",
		"[D8 9C]", "[D8 9D]", "[D8 9E]", "[D8 9F]",

		"[D8 A0]", "[D8 A1]", "[D8 A2]", "[D8 A3]",
		"[D8 A4]", "[D8 A5]", "[D8 A6]", "[D8 A7]",
		"[D8 A8]", "[D8 A9]", "[D8 AA]", "[D8 AB]",
		"[D8 AC]", "[D8 AD]", "[D8 AE]", "[D8 AF]",

		"[D8 B0]", "[D8 B1]", "[D8 B2]", "[D8 B3]",
		"[D8 B4]", "[D8 B5]", "[D8 B6]", "[D8 B7]",
		"[D8 B8]", "[D8 B9]", "[D8 BA]", "[D8 BB]",
		"[D8 BC]", "[D8 BD]", "[D8 BE]", "[D8 BF]",
	}
};

static void dec_init(void);

static long tbl_offset[NUM_TEXTDATA + 1];
static int flag_setdecode = 0;

static void dec_init(void)
{
	int i;
	unsigned char buf[SIZEOF_OFFSETADDR];

#ifndef NDEBUG
	{
		int i, j;

		for (i = 0; i < (int)(sizeof(tbl_charcode) / sizeof(tbl_charcode[0])); i++)
			for (j = 0; j < 64; j++)
				assert(tbl_charcode[i][j] != NULL);
	}
#endif

	/* ƥȥǡǼƤ륢ɥ쥹(ؤΥեå)ɤ߹ */
	for (i = 0; i < NUM_TEXTDATA; i++)
	{
		file_read(buf, FILEPOS_TEXT_ADDR + SIZEOF_OFFSETADDR * i, SIZEOF_OFFSETADDR);
		tbl_offset[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}
	/* üեå */
	{
		file_read(buf, FILEPOS_TEXT_EOF, SIZEOF_OFFSETADDR);
		tbl_offset[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}

	flag_setdecode = 1;
}

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize)
{
	int i;

	/* å */
	if (ptr_dstbuf == NULL || ptr_srcbuf == NULL || dstbufsize == 0 || srcbufsize == 0)
	{
		assert(0);
		return NULL;
	}

	/* ʸǥɤ */
	*ptr_dstbuf = '\0';
	for (i = 0; i < (int)srcbufsize; i++)
	{
		/* ޥХ (bit7  1) */
		if ((ptr_srcbuf[i] & 0x80) != 0x00)
		{
			if ((ptr_srcbuf[i] & 0x3f) < (int)(sizeof(tbl_charcode) / sizeof(tbl_charcode[0])))
			{
				assert(i + 1 < (int)srcbufsize - 1); /* üʸ (-1) ޤǤ뤫 */
				strncat(ptr_dstbuf, tbl_charcode[ptr_srcbuf[i] & 0x3f][ptr_srcbuf[i + 1] & 0x3f],
						dstbufsize - strlen(ptr_dstbuf) - 1);
			}
			else
				assert(0);

			/* 1 ʸʤ */
			i++;
		}
		/* 󥰥Х */
		else
		{
			/* bit6 ˤäʸɽѤ*/
			strncat(ptr_dstbuf, tbl_charcode[((ptr_srcbuf[i] & 0x40) != 0x00) ? 1 : 0][ptr_srcbuf[i] & 0x3f],
					dstbufsize - strlen(ptr_dstbuf) - 1);
		}
	}

	return ptr_dstbuf;
}

char *dec_msg(char *ptr_dstbuf, size_t dstbufsize, size_t id, enum flag_decode flag_decode)
{
	unsigned char *buf_srcbuf;
	size_t srcbufsize;

	/* ơ֥ͤꤵƤʤϡͤꤹ */
	if (!flag_setdecode)
		dec_init();

	/* å */
	if (ptr_dstbuf == NULL || dstbufsize == 0 || id >= NUM_MSGID)
	{
		assert(0);
		return NULL;
	}

	/* å ID ºݤΥåǡΰ֤˽ */
	id *= 2;
	if (flag_decode == FLAG_KANJI)
		id++;

	/* ХåեΥꤹ */
	if (tbl_offset[id + 1] - tbl_offset[id] <= 0)
	{
		assert(0);
		return NULL;
	}
	srcbufsize = tbl_offset[id + 1] - tbl_offset[id];

	/* Хåեݤ */
	if ((buf_srcbuf = malloc(srcbufsize)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ե뤫ʸХåեɤ߹ */
	file_read(buf_srcbuf, FILEPOS_TEXTDATA + tbl_offset[id], srcbufsize);

	/* ʸǥɤ */
	dec_string(ptr_dstbuf, buf_srcbuf, dstbufsize, srcbufsize);

	free(buf_srcbuf);
	buf_srcbuf = NULL;

	return ptr_dstbuf;
}

int dec_writedata(const char *ptr_filename, size_t region_decode_begin, int len_decode, enum flag_decode flag_decode)
{
	int i;
	FILE *fp = NULL;
	char *ptr;
	char buf[2048] = "";

	if (len_decode == -1)
		len_decode = NUM_MSGID - region_decode_begin;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || len_decode < 0)
	{
		assert(0);
		return 0;
	}

	/* åǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* 󥹥ΥåǡϤ */
	fprintf(fp, "No.         å\n");
	for (i = region_decode_begin; i < (int)region_decode_begin + len_decode; i++)
	{
		/* åǡϤ */
		dec_msg(buf, sizeof(buf), i, flag_decode);

		/* Ԥ򵭹֤ */
		while ((ptr = strrchr(buf, '\n')) != NULL)
			*ptr = '/';

		fprintf(fp, "%04d(%04X): %s\n", i, i, buf);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
