/*
 *	ff4define.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF4DEFINE_H)
#define FF4DEFINE_H

enum
{
	ELEM_IDX_FIRE,		/*  */
	ELEM_IDX_ICE,		/* ɹ */
	ELEM_IDX_THUNDER,	/*  */
	ELEM_IDX_DARKNESS,	/* Ź */
	ELEM_IDX_SACRED,	/*  */
	ELEM_IDX_ARROWS,	/* ƻ */
	ELEM_IDX_ABSORB,	/* ۼ */
	ELEM_IDX_EMPHASIS,	/* ()*/

	NUM_ELEMENT
};

enum
{
	STATE_IDX_POISON,			/*  */
	STATE_IDX_DARKNESS,			/* Ű */
	STATE_IDX_SILENT,			/*  */
	STATE_IDX_PORKY,			/*  */
	STATE_IDX_MINIMUM,			/*  */
	STATE_IDX_TOAD,				/*  */
	STATE_IDX_STONE,			/*  */
	STATE_IDX_SWOON,			/* Ʈǽ */

	STATE_IDX_BECOME_STONE,		/* в */
	STATE_IDX_BECOME_STONE_D,	/* в(ߡ) */
	STATE_IDX_BERSERK,			/*  */
	STATE_IDX_CONFUSE,			/*  */
	STATE_IDX_SLEEP,			/* ̲ */
	STATE_IDX_PARALYZE,			/*  */
	STATE_IDX_LEVITATE,			/* ӥƥ */
	STATE_IDX_CURSE,			/*  */

	STATE_IDX_BECOME_DEATH,		/*  */
	STATE_IDX_UNKNOWN17,		/*  */
	STATE_IDX_UNKNOWN18,		/*  */
	STATE_IDX_UNKNOWN19,		/*  */
	STATE_IDX_UNKNOWN20,		/*  */
	STATE_IDX_STOP,				/* ȥå */
	STATE_IDX_UNKNOWN22,		/*  */
	STATE_IDX_UNKNOWN23,		/*  */

	STATE_IDX_DEADLY,			/* λ */
	STATE_IDX_UNKNOWN25,		/*  */
	STATE_IDX_ILLUSION1,		/* ʬ(1) */
	STATE_IDX_ILLUSION2,		/* ʬ(2) */
	STATE_IDX_BARRIER,			/* Хꥢ */
	STATE_IDX_REFLECT,			/* ե쥯 */
	STATE_IDX_UNKNOWN30,		/*  */
	STATE_IDX_UNKNOWN31,		/*  */

	NUM_STATE
};

enum
{
	MONTYPE_IDX_DRAGON,		/* ɥ饴 */
	MONTYPE_IDX_MACHINE,	/*  */
	MONTYPE_IDX_LIZARD,		/* ꥶ */
	MONTYPE_IDX_PHANTOM,	/*  */
	MONTYPE_IDX_GIANT,		/*  */
	MONTYPE_IDX_PUDDING,	/* ץ */
	MONTYPE_IDX_MAGE,		/* ˡȤ */
	MONTYPE_IDX_UNDEAD,		/* ǥå */

	NUM_MONTYPE
};

#define ELEM_FIRE		(1U << ELEM_IDX_FIRE)
#define ELEM_ICE		(1U << ELEM_IDX_ICE)
#define ELEM_THUNDER	(1U << ELEM_IDX_THUNDER)
#define ELEM_DARKNESS	(1U << ELEM_IDX_DARKNESS)
#define ELEM_SACRED		(1U << ELEM_IDX_SACRED)
#define ELEM_ARROWS		(1U << ELEM_IDX_ARROWS)
#define ELEM_ABSORB		(1U << ELEM_IDX_ABSORB)
#define ELEM_EMPHASIS	(1U << ELEM_IDX_EMPHASIS)
#define ELEM_ALL		(ELEM_FIRE	| ELEM_ICE		| ELEM_THUNDER	| ELEM_DARKNESS	| \
						ELEM_SACRED	| ELEM_ARROWS	| ELEM_ABSORB	| ELEM_EMPHASIS)

#define STATE_POISON			(1U << STATE_IDX_POISON)
#define STATE_DARKNESS			(1U << STATE_IDX_DARKNESS)
#define STATE_SILENT			(1U << STATE_IDX_SILENT)
#define STATE_PORKY				(1U << STATE_IDX_PORKY)
#define STATE_MINIMUM			(1U << STATE_IDX_MINIMUM)
#define STATE_TOAD				(1U << STATE_IDX_TOAD)
#define STATE_STONE				(1U << STATE_IDX_STONE)
#define STATE_SWOON				(1U << STATE_IDX_SWOON)
#define STATE_PERMANENT			(STATE_POISON	| STATE_DARKNESS	| STATE_SILENT	| STATE_PORKY	| \
								STATE_MINIMUM	| STATE_TOAD		| STATE_STONE	| STATE_SWOON)

#define STATE_BECOME_STONE		(1U << STATE_IDX_BECOME_STONE)
#define STATE_BECOME_STONE_D	(1U << STATE_IDX_BECOME_STONE_D)
#define STATE_BERSERK			(1U << STATE_IDX_BERSERK)
#define STATE_CONFUSE			(1U << STATE_IDX_CONFUSE)
#define STATE_SLEEP				(1U << STATE_IDX_SLEEP)
#define STATE_PARALYZE			(1U << STATE_IDX_PARALYZE)
#define STATE_LEVITATE			(1U << STATE_IDX_LEVITATE)
#define STATE_CURSE				(1U << STATE_IDX_CURSE)
#define STATE_TEMPORARY			(STATE_BECOME_STONE	| STATE_BECOME_STONE_D	| STATE_BERSERK		| STATE_CONFUSE	| \
								STATE_SLEEP			| STATE_PARALYZE		| STATE_LEVITATE	| STATE_CURSE)

#define STATE_BECOME_DEATH		(1U << STATE_IDX_BECOME_DEATH)
#define STATE_STOP				(1U << STATE_IDX_STOP)
#define STATE_DEADLY			(1U << STATE_IDX_DEADLY)
#define STATE_ILLUSION1			(1U << STATE_IDX_ILLUSION1)
#define STATE_ILLUSION2			(1U << STATE_IDX_ILLUSION2)
#define STATE_BARRIER			(1U << STATE_IDX_BARRIER)
#define STATE_REFLECT			(1U << STATE_IDX_REFLECT)
#define STATE_OTHER				(STATE_BECOME_DEATH | STATE_STOP | \
								STATE_DEADLY | STATE_ILLUSION1 | STATE_ILLUSION2 | STATE_BARRIER | STATE_REFLECT)

#define STATE_ALL				(STATE_PERMANENT | STATE_TEMPORARY | STATE_OTHER)

#define MONTYPE_DRAGON		(1U << MONTYPE_IDX_DRAGON)
#define MONTYPE_MACHINE		(1U << MONTYPE_IDX_MACHINE)
#define MONTYPE_LIZARD		(1U << MONTYPE_IDX_LIZARD)
#define MONTYPE_PHANTOM		(1U << MONTYPE_IDX_PHANTOM)
#define MONTYPE_GIANT		(1U << MONTYPE_IDX_GIANT)
#define MONTYPE_PUDDING		(1U << MONTYPE_IDX_PUDDING)
#define MONTYPE_MAGE		(1U << MONTYPE_IDX_MAGE)
#define MONTYPE_UNDEAD		(1U << MONTYPE_IDX_UNDEAD)
#define MONTYPE_ALL			(MONTYPE_DRAGON	| MONTYPE_MACHINE	| MONTYPE_LIZARD	| MONTYPE_PHANTOM	| \
							MONTYPE_GIANT	| MONTYPE_PUDDING	| MONTYPE_MAGE		| MONTYPE_UNDEAD)

typedef unsigned char elem_t;
typedef unsigned long state_t;
typedef unsigned char montype_t;

const char *str_getflag(int flag);
const char *str_getelem(elem_t elem, int index);
void str_printelem(FILE *stream, elem_t elem, elem_t elem_mask);
const char *str_getstate(state_t state, int index);
void str_printstate(FILE *stream, state_t state, state_t state_mask);
const char *str_getmontype(montype_t montype, int index);
void str_printmontype(FILE *stream, montype_t montype, montype_t montype_mask);

#define ff4_signed_int(int)		(((int) > 127) ? ((int) - 256) : (int))

#define bits_make32(byte1, byte2, byte3, byte4)	(((unsigned long)(byte1) & 0xff) | \
												(((unsigned long)(byte2) & 0xff) <<  8) | \
												(((unsigned long)(byte3) & 0xff) << 16) | \
												(((unsigned long)(byte4) & 0xff) << 24))

#endif /* FF4DEFINE_H */
