/*
 *	ff4file.c
 *		Copyright (C) 2008 Inu
 */

#include <stdlib.h>
#include "file.h"

struct e4_filelayout_tag
{
	long filepos;
	long offset;
};

static int ff4_file_version = 0;

static struct e4_filelayout_tag tbl_e4_layout[] =
{
	{  0x000000,      0 },
	{  0x0da760,   -676 },	/* FILEPOS_MONENC */
	{  0x0db42c,   -676 },	/* FILEPOS_MONMAP1 */
	{  0x0dbcac,   -676 },	/* FILEPOS_MONMAP2 */
	{  0x0e5dcc,  -3120 },	/* FILEPOS_ITEMEQUIP */
	{  0x0e68b0,  -3120 },	/* FILEPOS_MAGDATA */
	{  0x0e7bf0,  -3120 },	/* FILEPOS_CHRLVUP */
	{  0x0ec578,  -3120 },	/* FILEPOS_ITEMEFFECT */
	{  0x0ecfa0,  -3120 },	/* FILEPOS_ITEMDATA */
	{  0x0f2eb0,  -3100 },	/* FILEPOS_CHRDATA */
	{  0x0f5850,  -3100 },	/* FILEPOS_CHRCRITICAL */
	{  0x0f94e8,  -3100 },	/* FILEPOS_MONDATA */
	{  0x0fb484,  -3100 },	/* FILEPOS_MONITEM */
	{  0x0fc210,  -3100 },	/* FILEPOS_MONELEM */
	{  0x0fcb18,  -3100 },	/* FILEPOS_MONPARTY_FLAG */
	{  0x0fe290,  -3100 },	/* FILEPOS_MONPARTY_ADDR */
	{  0x2e2ee8, -87768 },	/* FILEPOS_TEXTDATA */
	{ 0x8000000,      0 },
};

int ff4_file_open(const char *ptr_path, const char *ptr_title, enum filemode_type mode)
{
	int ret = file_open(ptr_path, ptr_title, mode);

	/* GBA $BHG$N>l9g$O%P!<%8%g%s>pJs$rFI$_9~$`(B */
	if (ret && mode == FILEMODE_GBA)
		file_read(&ff4_file_version, 0x0000bc, 1);

	return ret;
}

int ff4_get_version(void)
{
	return ff4_file_version;
}

size_t ff4_file_read(void *ptr_buf, long filepos, size_t size)
{
	/* $B%P!<%8%g%s$K$h$C$F%U%!%$%k0LCV$r=$@5$9$k(B */
	if (ff4_file_version == 1)
	{
		size_t index;

		for (index = 0; index < sizeof(tbl_e4_layout) / sizeof(tbl_e4_layout[0]) - 1; index++)
		{
			if (filepos < tbl_e4_layout[index + 1].filepos)
				break;
		}
		filepos += tbl_e4_layout[index].offset;
	}

	return file_read(ptr_buf, filepos, size);
}
