/*
 *	ff4item.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF4ITEM_H)
#define FF4ITEM_H

#include "ff4define.h"
#include "ff4magic.h"

typedef struct weapon_tag
{
	int attack_power;				/*  */
	int hit_rate;					/* ̿Ψ */
	int increase_strength;			/* Ͼ徺 */
	int increase_speed;				/* ®徺 */
	int increase_stamina;			/* Ͼ徺 */
	int increase_wisdom;			/* 徺 */
	int increase_will_power;		/* 徺 */
	elem_t elem_attack;				/* ̾ﹶ° */
	state_t state_attack;			/* ̾ﹶξѲ */
	montype_t montype_attack;		/* ͭ󥹥 */
	unsigned long bits_equip_chr;	/* ǽ饯 */
	int flag_magnetic;				/* Ϥαƶ */
	int flag_throw;					/* ꤲ */
	int flag_backrow;				/* 󤫤ǤϤ㲼ʤ */
	int flag_good_hand;				/* ǻ */
	int flag_weak_hand;				/* Ȥϵդμǻ */
	int flag_2handed;				/* ξǤ */
} weapon_t;

typedef struct protector_tag
{
	int defense_power;				/* ɸ */
	int evade_rate;					/* Ψ */
	int magic_defense_power;		/* ˡɸ */
	int magic_evade_rate;			/* ˡΨ */
	int increase_strength;			/* Ͼ徺 */
	int increase_speed;				/* ®徺 */
	int increase_stamina;			/* Ͼ徺 */
	int increase_wisdom;			/* 徺 */
	int increase_will_power;		/* 徺 */
	elem_t elem_defense;			/* °ؤ */
	state_t state_defense;			/* Ѳؤ */
	montype_t montype_defense;		/* ͭ󥹥 */
	unsigned long bits_equip_chr;	/* ǽ饯 */
	int flag_magnetic;				/* Ϥαƶ */
} protector_t;

typedef magdata_t tool_t;

union itemparam_t
{
	weapon_t weapon;		/* 異ƥǡ */
	protector_t protector;	/* ɶ񥢥ƥǡ */
	tool_t tool;			/* Ʈƥǡ */
};

typedef struct itemdata_tag
{
	int type;					/* (ITEM_TYPE_WEAPONITEM_TYPE_OTHER) */
	int type_no;				/*  */
	long price;					/*  */
	int effect_no;				/* ѻθ */
	int flag_use;				/* ˥塼(0x01)/Ʈ(0x02)/֥ݥ(0x04)ǻѲǽ */
	int flag_bank;				/* ¤ǽ */
	union itemparam_t param;	/* ƥǡ */
} itemdata_t;

enum	/* itemdata_tag.type */
{
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_PROTECTOR,	/* ɶ */
	ITEM_TYPE_TOOL,			/* Ʈƥ */
	ITEM_TYPE_OTHER,		/* ̾異ƥ */
	ITEM_TYPE_NUM
};

const char *item_getname(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelem(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestate(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeflag(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeparambug(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* FF4ITEM_H */
