/*
 *	ff4monster.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF4MONSTER_H)
#define FF4MONSTER_H

#include "ff4define.h"
#include "ff4item.h"
#include "ff4magic.h"

typedef struct mondata_tag
{
	int level;					/* ٥ */
	long hit_point;				/* ҥåȥݥ */
	long magic_point;			/* ޥåݥ */
	long experience_point;		/* и */
	long gil;					/*  */
	int attack_times;			/*  */
	int attack_power;			/*  */
	int hit_rate;				/* ̿Ψ */
	int defense_times;			/* ɸ */
	int defense_power;			/* ɸ */
	int evade_rate;				/* Ψ */
	int magic_defense_times;	/* ˡɸ */
	int magic_defense_power;	/* ˡɸ */
	int magic_evade_rate;		/* ˡΨ */
	int magic_attack_times;		/* ˡ */
	int magic_power;			/*  */
	int speed[2];				/* ® */
	int speed_rate;				/* ư®٤ν */
	int item_get;				/* ꤷ䤹 */
	int flag_boss;				/* ܥǤ */
	elem_t elem_defense;		/* °ؤ */
	elem_t elem_weakness;		/* ° */
	state_t state_attack;		/* ̾ﹶξѲ */
	state_t state_defense;		/* Ѳؤ */
	montype_t montype;			/* 󥹥 */
	int item_no[4];				/* ƥ */
	int actptn_no[2];			/* ưѥֹ */
} mondata_t;

typedef struct monact_tag
{
	struct
	{
		size_t action_size;		/* ưѥǡΥХȿ */
		int condition_no[3];	/* ŬѾǡ */
		unsigned char *action;	/* ưѥǡ */
	} ptn[16];
} monact_t;

typedef struct monparty_tag
{
	struct
	{
		int num;
		int index;
		int monster_no[8];
		int flag_eggy;
	} grp[3];

	int monster_num;		/* 󥹥ο */
	int monster_no[8];		/* 󥹥μ */
	int group_no[8];		/* 롼ֹ */
	int position_x[8];		/* 󥹥ΰ (X ɸ) */
	int position_y[8];		/* 󥹥ΰ (Y ɸ) */
	int background_no;		/* Ʈط */
	int music_no;			/* Ʈ */
	int flag_eggy[8];		/* Ʈϻ˥󥹥ߥƥ쥰äƤ */
	int flag_exist[3];		/* Ʈϻ˥󥹥иƤʤ */
	int flag_escape;		/* ƨǽǤ */
	int flag_float;			/* ͷƤ */
	int flag_preemptive;	/* Ʈ򳫻Ϥ */
	int flag_backattack;	/* ХååƮ򳫻Ϥ */
	int flag_surprise;		/* ԰ǤƮ򳫻Ϥ */
	int flag_event;			/* ٥ƮǤ */
} monparty_t;

typedef struct monenc_tag
{
	int party_no[8];		/* 󥹥ѡƥμ */
} monenc_t;

typedef struct monmap_tag
{
	monenc_t area[8][8];
} monmap_t;

typedef struct triplet_tag
{
	int times;	/*  */
	int power;	/*  */
	int rate;	/* Ψ */
} triplet_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monact_t *mon_readact(void);
monparty_t *mon_readparty(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeelem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writestate(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const monact_t *ptr_monact, const mondata_t *ptr_mondata);
int mon_writemes(const char *ptr_filename);
int mon_writeparty(const char *ptr_filename, const monparty_t *ptr_monparty);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);
void mon_freeact(monact_t *ptr_monact);
void mon_printparty(FILE *stream, const monparty_t *ptr_monparty);

#endif /* FF4MONSTER_H */
