/*
 *	file.c
 *		Copyright (C)2001, 2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdlib.h>
#include <assert.h>
#include "filegba.h"
#include "file.h"

static enum filemode_type file_mode = FILEMODE_UNKNOWN;	/* ե륢Υ⡼ */
static size_t (*ptr_func_file_read)(void *, long, size_t) = NULL;	/* ե꡼ѴؿΥݥ */

int file_open(const char *ptr_path, const char *ptr_title, enum filemode_type mode)
{
	/* å */
	if (ptr_path == NULL)
	{
		assert(0);
		return 0;
	}

	file_mode = FILEMODE_UNKNOWN;

	if (mode == FILEMODE_GBA)
	{
		if (!file_open_gba(ptr_path, ptr_title))
			return 0;

		file_mode = FILEMODE_GBA;
		ptr_func_file_read = file_read_gba;
	}
	else
	{
		assert(0);
		return 0;
	}

	return 1;
}

int file_close(void)
{
	int ret = 0;

	if (file_mode == FILEMODE_GBA)
		ret = file_close_gba();
	else
		assert(0);

	file_mode = FILEMODE_UNKNOWN;
	ptr_func_file_read = NULL;

	return ret;
}

size_t file_read(void *ptr_buf, long filepos, size_t size)
{
	/* ѿå */
	if (ptr_func_file_read == NULL)
	{
		assert(0);
		return 0;
	}

	return ptr_func_file_read(ptr_buf, filepos, size);
}
