/*
 *	filegba.c
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "filegba.h"

#define FILEPOS_GBA_ROM_AREA		0x8000000
#define FILEPOS_GBA_HEADER			0x0000000
#define SIZEOF_GBA_HEADER			0x00000c0

static FILE *fp_gba = NULL;		/* եݥ */

int file_open_gba(const char *ptr_filename, const char *ptr_title)
{
	unsigned char buf[SIZEOF_GBA_HEADER];
	const long filepos_title = 0xa0;
	const size_t sizeof_title = 12;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_title == NULL || *ptr_title == '\0')
	{
		assert(0);
		return 0;
	}

	/* ROM ᡼ե򳫤 */
	if ((fp_gba = fopen(ptr_filename, "rb")) == NULL)
		return 0;

	/* إåγǼ֤˰ư */
	if (fseek(fp_gba, FILEPOS_GBA_HEADER, SEEK_SET))
		err_printf(STR_FATAL_ERROR_IN_FSEEK);

	/* إåɤ߹ */
	if (fread(buf, 1, sizeof(buf), fp_gba) < sizeof(buf))
		err_printf(STR_FATAL_ERROR_IN_FREAD);

	/* ॿȥγǧ */
	if (memcmp(&buf[filepos_title], ptr_title, sizeof_title) != 0)
	{
		file_close_gba();
		return 0;
	}

	/* եݥ󥿤եƬ֤᤹ */
	if (fseek(fp_gba, 0, SEEK_SET))
		err_printf(STR_FATAL_ERROR_IN_FSEEK);

	return 1;
}

int file_close_gba(void)
{
	if (fp_gba == NULL)
	{
		assert(0);
		return 0;
	}

	if (fclose(fp_gba) == EOF)
		err_printf(STR_FATAL_ERROR_IN_FCLOSE);

	/* ǡ */
	fp_gba = NULL;

	return 1;
}

size_t file_read_gba(void *ptr_buf, long position, size_t size)
{
	size_t ret = 0;

	/* å */
	if (ptr_buf == NULL || position < 0)
	{
		assert(0);
		return 0;
	}

	if (position >= FILEPOS_GBA_ROM_AREA)
		position -= FILEPOS_GBA_ROM_AREA;

	if (fseek(fp_gba, position, SEEK_SET))
		err_printf(STR_FATAL_ERROR_IN_FSEEK);

	if ((ret = fread(ptr_buf, 1, size, fp_gba)) < size)
		err_printf(STR_FATAL_ERROR_IN_FREAD);

	return ret;
}
