/*
 *	utility.c
 *		Copyright (C)2001-2003 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "utility.h"

#define PATH_DELIMITER_UNIX_WIN32	'/'		/* UNIXWin32Ƕ̤˻Ȥѥǥߥ */
#define PATH_DELIMITER_WIN32		'\\'	/* Win32ǤΤ߻Ȥѥǥߥ */

char *transpath(char *ptr_dstpath, const char *ptr_srcpath, size_t bufsize)
{
	char *buf_dstpath = NULL;
	char *ptr = NULL;

	/* å */
	if (ptr_dstpath == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcpath == NULL || bufsize == 0)
	{
		assert(0);
		return ptr_dstpath;
	}

	/* Хåեΰ褬ʬ뤫å */
	if (bufsize <= strlen(ptr_srcpath) + 2)		/* "2"ղäǽ'/'ȥ̥륿ߥ͡ιץ */
		return ptr_dstpath;

	/* Хåեݤʸ򥳥ԡ */
	if ((buf_dstpath = malloc(bufsize)) == NULL)
		return ptr_dstpath;

	strncpy(buf_dstpath, ptr_srcpath, bufsize);
	buf_dstpath[bufsize - 1] = '\0';

	/* ѥǥߥѴ */
	while ((ptr = strchr(buf_dstpath, PATH_DELIMITER_WIN32)) != NULL)
	{
		assert(buf_dstpath <= ptr && ptr < buf_dstpath + bufsize);
		*ptr = PATH_DELIMITER_UNIX_WIN32;
	}

	/* ѥ'/'Ǥʤϡ'/'ղä */
	ptr = strrchr(buf_dstpath, '\0');
	if (ptr > buf_dstpath)
	{
		ptr--;
		assert(buf_dstpath <= ptr && ptr < buf_dstpath + bufsize);
		if (*ptr != PATH_DELIMITER_UNIX_WIN32)
		{
			*++ptr = PATH_DELIMITER_UNIX_WIN32;
			assert(buf_dstpath <= ptr && ptr < buf_dstpath + bufsize);
			*++ptr = '\0';
		}
	}

	/* ХåեƤϤ */
	strncpy(ptr_dstpath, buf_dstpath, bufsize);
	buf_dstpath[bufsize - 1] = '\0';

	free(buf_dstpath);
	buf_dstpath = NULL;

	return ptr_dstpath;
}

char *transfilename(char *ptr_dstfilename, const char *ptr_srcfilename, size_t bufsize)
{
	char *buf_dstfilename = NULL;
	char *ptr = NULL;

	/* å */
	if (ptr_dstfilename == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcfilename == NULL || bufsize == 0)
	{
		assert(0);
		return ptr_dstfilename;
	}

	/* Хåեΰ褬ʬ뤫å */
	if (bufsize <= strlen(ptr_srcfilename) + 1)
		return ptr_dstfilename;

	/* Хåեݤʸ򥳥ԡ */
	if ((buf_dstfilename = malloc(bufsize)) == NULL)
		return ptr_dstfilename;

	strncpy(buf_dstfilename, ptr_srcfilename, bufsize);
	buf_dstfilename[bufsize - 1] = '\0';

	/* ѥǥߥѴ */
	while ((ptr = strchr(buf_dstfilename, PATH_DELIMITER_WIN32)) != NULL)
	{
		assert(buf_dstfilename <= ptr && ptr < buf_dstfilename + bufsize);
		*ptr = PATH_DELIMITER_UNIX_WIN32;
	}

	/* ХåեƤϤ */
	strncpy(ptr_dstfilename, buf_dstfilename, bufsize);
	buf_dstfilename[bufsize - 1] = '\0';

	free(buf_dstfilename);
	buf_dstfilename = NULL;

	return ptr_dstfilename;
}
