/*
 *	ff5character.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *	 	Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5CHARACTER_H)
#define FF5CHARACTER_H

#include "ff5define.h"
#include "ff5magic.h"

#define NUM_CHRLV			99
#define NUM_CHRJOBLVUPMAX	7

typedef struct chrparam_tag
{
	int strength;		/*  */
	int speed;			/* ® */
	int stamina;		/*  */
	int magic_power;	/*  */
} chrparam_t;

typedef struct chrdata_tag
{
	int id;						/* ID */
	int job;					/*  */
	int level;					/* ٥ */
	long experience_point;		/* и */
	int hit_point;				/* ҥåȥݥ */
	int magic_point;			/* ޥåݥ */
	int strength;				/*  */
	int speed;					/* ® */
	int stamina;				/*  */
	int magic_power;			/*  */
	int caught_monster;			/* ᤨ󥹥 */
	int defense_power;			/* ɸ */
	int evade_rate;				/* Ψ */
	int magic_defense_power;	/* ˡɸ */
	int magic_evade_rate;		/* ˡΨ */
	chrparam_t increase;

	int cmd_no[4];			/* ޥ */
	int equip_no[5];		/* ƥ */
	int equip_weight;		/* νŤ */
	int flag_backrow;		/* Ǥ */
	int flag_exist;			/* ѡƥСǤ */
	int flag_female;		/* 饯Ǥ */
} chrdata_t;

typedef struct chrlvup_tag
{
	long experience_point;	/* и */
	int hit_point;			/* ܥҥåȥݥ */
	int magic_point;		/* ܥޥåݥ */
} chrlvup_t;

typedef struct chrjob_tag
{
	chrparam_t chrparam;

	int cmd_no[4];		/* ޥ */
	int level_max;		/* 祸֥٥ */
	struct
	{
		int ability_point;	/* ɬץӥƥݥ */
		int ability_no;		/* 륢ӥƥ */
	} level[NUM_CHRJOBLVUPMAX];

	unsigned int bits_abt_effect;		/*  */
	unsigned int bits_equip_weapon;		/* ǽ */
	unsigned int bits_equip_protector;	/* ǽɶ */
} chrjob_t;

typedef magdata_t cmddata_t;

typedef struct chrcmd_tag
{
	cmddata_t param;
	chrparam_t chrparam;

	int flag_human_attack;		/* ʹַϥ󥹥˹ϡ2 */
	int flag_swdslap_attack;	/* ߤͤ(̤?) */
	int flag_ignore_defense;	/* оݤɸϤ̵뤹 */
	int flag_multiplier_half;	/* Ψ2 */
	int flag_multiplier_double;	/* Ψ2 */
	int flag_attack_half;		/* ϡ2 */
	int flag_attack_double;		/* ϡ2 */
	int flag_always_hit;		/* ɬ̿椹 */

	int effect_type;			/* ̥ */
	int time_wait;				/* ޥɼ¹ԸθȯưޤǤλ */
} chrcmd_t;

typedef struct chrabt_tag
{
	chrparam_t chrparam;

	unsigned int bits_abt_effect;		/* ӥƥ */
	unsigned int bits_equip_weapon;		/* ǽ */
	unsigned int bits_equip_protector;	/* ǽɶ */
} chrabt_t;

const char *chr_getname(int index);
const char *chr_getjobname(int index);
const char *chr_getcmdname(int index);
const char *chr_getabtname(int index);
const char *chr_getcmdtypename(int index);
chrdata_t *chr_readdata(void);
chrlvup_t *chr_readlvup(void);
chrjob_t *chr_readjob(void);
chrcmd_t *chr_readcmd(void);
chrabt_t *chr_readabt(void);
int chr_writeparam(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writeequip(const char *ptr_filename, const chrdata_t *ptr_chrdata);
int chr_writelvup(const char *ptr_filename, const chrlvup_t *ptr_chrlvup);
int chr_writejob(const char *ptr_filename, const chrjob_t *ptr_chrjob);
int chr_writecmdparam(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdelem(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdcategory(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdstate(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdflag(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writeabtparam(const char *ptr_filename, const chrabt_t *ptr_chrabt);

#endif /* FF5CHARACTER_H */
