/*
 *	ff5decode.c
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "file.h"
#include "ff5decode.h"

#define FILEPOS_TEXTDATA		0x36e62c
#define FILEPOS_TEXT_FLAG		(FILEPOS_TEXTDATA + 0x08)
#define FILEPOS_TEXT_SIZE		(FILEPOS_TEXTDATA + 0x09)
#define FILEPOS_TEXT_EOF		(FILEPOS_TEXTDATA + 0x0c)
#define FILEPOS_TEXT_ADDR		(FILEPOS_TEXTDATA + 0x10)
#define NUM_MSGID				6168
#define NUM_TEXTDATA			(NUM_MSGID * 2)
#define SIZEOF_OFFSETADDR		4

/* եʥե󥿥 V ɥХ󥹤ʸɽ */
static const char *tbl_charcode[21][64] =
{
	/* 0xc0 */
	{
		"\0", " ",  "", "", "", "", "!",  "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "?",  "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xc1 */
	{
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "1",  "", "", "0",  "", "", "", "",
		"", "", "", "", "", "", "", "2",  "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "F",  "", "", "", "", "", "",
	},

	/* 0xc2 */
	{
		"", "", "", "", "", "", "3",  "", "", "", "4",  "", "", "ã", "", "",
		"", "", "", "", "", "", "", "", "", "ʪ", "", "", "", "", "P",  "ε",
		"", "", "", "", "", "", "5",  "", "", "", "", "", "", "", "", "̵",
		"", "", "", "", "", "", "", "", "B",  "", "", "", "", "", "", "",
	},

	/* 0xc3 */
	{
		"", "", "", "", "", "", "", "H",  "ʬ", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "ˡ", "", "", "", "", "", "", "",
		"", "", "", "M",  "", "Į", "ǯ", "", "", "ʼ", "", "6",  "ƻ", "", "8",  "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "ʹ",
	},

	/* 0xc4 */
	{
		"", "", "", "", "", "", "", "", "", "ư", "¼", "", "", "", "", "",
		"", "", "±", "", "", "", "", "", "", "̲", ":",  "7",  "", "", "ȯ", "/",
		"", "", "", "", "", "", "ι", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "Ĺ", "ή", "", "", "", "", "", "",
	},

	/* 0xc5 */
	{
		"Ω", "", "̿", "", "A",  "ƶ", "", "", "Ũ", "", "", "", "L",  "9",  "ï", "",
		"", "", "%",  "", "", "", "", "", "", "", "", "", "", "", "", "ɬ",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "ĥ", "", "Ϸ", "", "", "", "", "", "",
	},

	/* 0xc6 */
	{
		"E",  "T",  "", "", "ɱ", "Ʊ", "", "", "õ", "", "", "", "", "", "", "",
		"", "", "", "", "̾", "", "", "Ʈ", "", "", "", "¦", "", "", "", "",
		"ͽ", "R",  "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "˴", "ë", "ê", "", "³", "", "", "ͦ", "", "", "",
	},

	/* 0xc7 */
	{
		"", "", "", "", "", "", "0",  "", "", "ǽ", "", "", "Ϣ", "", "", "",
		"", "", "", "", "", "", "", "", "Ȣ", "", "", "", "", "", "", "",
		"", "Ĵ", "", "", "", "", "", "", ""/*MINUS*/, " ",  "", "", "", "ľ", "", "ȴ",
		"", "", "", "", "", "", "", "", "", "", "C",  "X",  "", "", "Ƭ", "¿",
	},

	/* 0xc8 */
	{
		"", "ϴ", "", "Ļ", "", "", "", "", "", "æ", "", "", "˺", "", "", "",
		"", "", "", "", "ˤ", "", "", "¸", "", "", "", "", "Ǥ", "", "", "",
		"", "", "", "", "", "", "", "", "", "Φ", "", "", "", "", "", "ʸ",
		"", "", "", "", "", "", "", "", "", "ϭ", "S",  "+",  "¾", "", "", "",
	},

	/* 0xc9 */
	{
		"ƨ", "˾", "΢", "", "", "", "", "Υ", "", "", "", "", "", "ñ", "Ⱦ", "",
		"", "", "", "", "", "©", "", "", "F",  "", "K",  "O",  "V",  "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "̣", "", "",
		"", "ͥ", "ɤ", "ȿ", "", "ǳ", "", "̩", "ͷ", "", "", "«", "̴", "", "ǰ", "",
	},

	/* 0xca */
	{
		"", "ϰ", "", "", "", "", "E",  "P",  "", "", "", "", "", "", "", "­",
		"Ū", "(",  ")",  "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "¤", "˻", "", "", "", "", "Ψ", "ͧ",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "B",  "", "C",
	},

	/* 0xcb */
	{
		"G",  "I",  "a",  "b",  "c",  "d",  "e",  "f",  "g",  "h",  "i",  "j",  "k",  "l",  "m",  "n",
		"o",  "p",  "q",  "r",  "s",  "t",  "u",  "v",  "w",  "x",  "y",  "z",  "%",  ":",  "", "",
		"", "", "", "", "", "", "", "", "", "ͩ", "", "", "", "", "", "",
		"", "", "ϵ", "˽", "", "", "", "", "", "", "", "", "ʧ", "¹", "·", "",
	},

	/* 0xcc */
	{
		"", "", "", "", "", "", "", "", "", "ǧ", "", "", "", "", "", "Ϳ",
		"", "", "ʿ", "", "Ź", "", "", "", "", "", "", "", "", "ĩ", "", "1",
		"A",  "X",  "¡", "", "", "", "", "", "", "", "", "", "D",  "J",  "N",  "Q",
		"U",  "W",  "Y",  "Z",  ".",  ".",  "-",  "+",  "+",  "+",  "+",  "+",  "", "", "", "",
	},

	/* 0xcd */
	{
		"", "", "", "ĺ", "", "", "", "", "", "", "", "", "ɽ", "ϩ", "ξ", "",
		"ɺ", "", "", "", "", "˼", "", "", "˭", "", "", "", "", ";", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"£", "", "", "", "", "̼", "²", "", "", "", "", "", "", "", "", "",
	},

	/* 0xce */
	{
		"", "", "ɡ", "", "", "", "", "", "Ƴ", "", "", "", "", "", "Ƥ", "",
		"", "", "", "ˬ", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "!",  ".",  "", "Ŷ", "", "", "/",  "T",  "Y",  "2",
		"3",  "4",  "5",  "6",  "U",  "S",  "M",  "", "", "", "", "", "", "", "", "",
	},

	/* 0xcf */
	{
		"", "", "", "", "®", "", "α", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "ɹ", "̱", "", "", "", "", "Ǻ", "", "", "",
		"Ǧ", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "»", "˰", "", "", "", "", "", "", "", "",
	},

	/* 0xd0 */
	{
		"", "", "", "", "", "", "", "", "ͳ", "", "", "", "Ʒ", "", "ά", "",
		"ô", "", "", "", "", "", "ˢ", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "ʤ", "", "", "Ϻ", "", "ڼ", "", "", "", "", "", "", "",
	},

	/* 0xd1 */
	{
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "̯",
		"ί", "", "", "ʮ", "", "", "á", "Ħ", "", "", "̤", "", "", "", "", "",
		"", "", "", "", "ϡ", "ȼ", "ͺ", "", "ͪ", "", "", "", "Ŵ", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "§", "",
	},

	/* 0xd2 */
	{
		"", "", "", "", "", "λ", "å", "", "", "", "", "", "", "", "", "",
		"", "Ǽ", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},

	/* 0xd3 */
	{
		"9",  ";",  "<",  "=",  ">",  "?",  "@",  "D",  "G",  "H",  "I",  "J",  "K",  "L",  "M",  "N",
		"Q",  "R",  "V",  "W",  "Z",  "[",  "\\", "]",  "~",  "_",  "~",  "{",  "|",  "}",  "~",  "",

		/* 楳(0xa00xaf) */
		"\n", "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",

		/* 楳(0xb00xb6) */
		"",   "",   "",   "",   "",   "",   "",

		/* 饰եå򼨤楳(0xd3b70xd484) */
		"",   "",   "",   "",   "",   "",   "",   "",   "",
	},

	/* 0xd4 */
	{
		/* 饰եå򼨤楳(0xd3b70xd484) */
		"",   "",   "",   "",   "",

		/* 楳(0x850x88) */
		"Хå", "%s",  "%d",  "%s",

		/* Ԥ򼨤楳(0x89) */
		"",

		/* ڡ򼨤楳(0x8a)*/
		"",

		/* ߤ򼨤楳(0x8b0x91) */
		"",   "",   "",   "",   "",   "",   "",

		/* 楳(0x920x98) */
		"%d", "%d", "%d", "%s", "%s", "%s", "%s",

		/* (0x990xbf) */
		"", "", "", "", "", "", "",
		"", "", "", "",   "\n", "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},
};

static void dec_init(void);

static long tbl_offset[NUM_TEXTDATA + 1];
static int flag_setdecode = 0;

static void dec_init(void)
{
	int i;
	unsigned char buf[SIZEOF_OFFSETADDR];

#ifndef NDEBUG
	{
		int i, j;

		for (i = 0; i < (int)(sizeof(tbl_charcode) / sizeof(tbl_charcode[0])); i++)
			for (j = 0; j < 64; j++)
				assert(tbl_charcode[i][j] != NULL);
	}
#endif

	/* ƥȥǡǼƤ륢ɥ쥹(ؤΥեå)ɤ߹ */
	for (i = 0; i < NUM_TEXTDATA; i++)
	{
		file_read(buf, FILEPOS_TEXT_ADDR + SIZEOF_OFFSETADDR * i, SIZEOF_OFFSETADDR);
		tbl_offset[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}
	/* üեå */
	{
		file_read(buf, FILEPOS_TEXT_EOF, SIZEOF_OFFSETADDR);
		tbl_offset[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}

	flag_setdecode = 1;
}

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize)
{
	int i;

	/* å */
	if (ptr_dstbuf == NULL || ptr_srcbuf == NULL || dstbufsize == 0 || srcbufsize == 0)
	{
		assert(0);
		return NULL;
	}

	/* ʸǥɤ */
	*ptr_dstbuf = '\0';
	for (i = 0; i < (int)srcbufsize; i++)
	{
		/* ޥХ (bit7  1) */
		if ((ptr_srcbuf[i] & 0x80) != 0x00)
		{
			if ((ptr_srcbuf[i] & 0x3f) < (int)(sizeof(tbl_charcode) / sizeof(tbl_charcode[0])))
			{
				assert(i + 1 < (int)srcbufsize - 1); /* üʸ (-1) ޤǤ뤫 */
				strncat(ptr_dstbuf, tbl_charcode[ptr_srcbuf[i] & 0x3f][ptr_srcbuf[i + 1] & 0x3f],
						dstbufsize - strlen(ptr_dstbuf) - 1);
			}
			else
				assert(0);

			/* 1 ʸʤ */
			i++;
		}
		/* 󥰥Х */
		else
		{
			/* bit6 ˤäʸɽѤ*/
			strncat(ptr_dstbuf, tbl_charcode[((ptr_srcbuf[i] & 0x40) != 0x00) ? 1 : 0][ptr_srcbuf[i] & 0x3f],
					dstbufsize - strlen(ptr_dstbuf) - 1);
		}
	}

	return ptr_dstbuf;
}

char *dec_msg(char *ptr_dstbuf, size_t dstbufsize, size_t id, enum flag_decode flag_decode)
{
	unsigned char *buf_srcbuf;
	size_t srcbufsize;

	/* ơ֥ͤꤵƤʤϡͤꤹ */
	if (!flag_setdecode)
		dec_init();

	/* å */
	if (ptr_dstbuf == NULL || dstbufsize == 0 || id >= NUM_MSGID)
	{
		assert(0);
		return NULL;
	}

	/* å ID ºݤΥåǡΰ֤˽ */
	id *= 2;
	if (flag_decode == FLAG_KANJI)
		id++;

	/* ХåեΥꤹ */
	if (tbl_offset[id + 1] - tbl_offset[id] <= 0)
	{
		assert(0);
		return NULL;
	}
	srcbufsize = tbl_offset[id + 1] - tbl_offset[id];

	/* Хåեݤ */
	if ((buf_srcbuf = malloc(srcbufsize)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ե뤫ʸХåեɤ߹ */
	file_read(buf_srcbuf, FILEPOS_TEXTDATA + tbl_offset[id], srcbufsize);

	/* ʸǥɤ */
	dec_string(ptr_dstbuf, buf_srcbuf, dstbufsize, srcbufsize);

	free(buf_srcbuf);
	buf_srcbuf = NULL;

	return ptr_dstbuf;
}

int dec_writedata(const char *ptr_filename, size_t region_decode_begin, int len_decode, enum flag_decode flag_decode)
{
	int i;
	FILE *fp = NULL;
	char *ptr;
	char buf[2048] = "";

	if (len_decode == -1)
		len_decode = NUM_MSGID - region_decode_begin;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || len_decode < 0)
	{
		assert(0);
		return 0;
	}

	/* åǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* 󥹥ΥåǡϤ */
	fprintf(fp, "No.         å\n");
	for (i = region_decode_begin; i < (int)region_decode_begin + len_decode; i++)
	{
		/* åǡϤ */
		dec_msg(buf, sizeof(buf), i, flag_decode);

		/* Ԥ򵭹֤ */
		while ((ptr = strrchr(buf, '\n')) != NULL)
			*ptr = '/';

		fprintf(fp, "%04d(%04X): %s\n", i, i, buf);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
