/*
 *	ff5define.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2009 Inu
 */

#if !defined(FF5DEFINE_H)
#define FF5DEFINE_H

enum
{
	ELEM_IDX_FIRE,		/*  */
	ELEM_IDX_ICE,		/*  */
	ELEM_IDX_THUNDER,	/*  */
	ELEM_IDX_POISON,	/*  */
	ELEM_IDX_SACRED,	/*  */
	ELEM_IDX_EARTH,		/*  */
	ELEM_IDX_WIND,		/*  */
	ELEM_IDX_WATER,		/*  */

	NUM_ELEMENT
};

enum
{
	CATEGORY_IDX_ENEMY,		/* ƤΤ虜 */
	CATEGORY_IDX_WHITE,		/* ˡ */
	CATEGORY_IDX_BLACK,		/* ˡ */
	CATEGORY_IDX_TIME,		/*  */
	CATEGORY_IDX_SUMMON,	/*  */
	CATEGORY_IDX_WAVE,		/*  */
	CATEGORY_IDX_LONG,		/*  */
	CATEGORY_IDX_SHORT,		/*  */

	NUM_CATEGORY
};

enum
{
	STATE_IDX_DARKNESS,		/* Ű */
	STATE_IDX_ZOMBIE,		/* ӡ */
	STATE_IDX_POISON,		/*  */
	STATE_IDX_LEVITATE,		/* ӥƥ */
	STATE_IDX_MINIMUM,		/* ߥ˥ޥ */
	STATE_IDX_TOAD,			/*  */
	STATE_IDX_STONE,		/* в */
	STATE_IDX_SWOON,		/* Ʈǽ */

	STATE_IDX_ILLUSION,		/* ʬ1 */
	STATE_IDX_ILLUSION_D,	/* ʬ2 */
	STATE_IDX_SILENT,		/*  */
	STATE_IDX_BERSERK,		/* С */
	STATE_IDX_CONFUSE,		/*  */
	STATE_IDX_PARALYZE,		/*  */
	STATE_IDX_SLEEP,		/* ̲ */
	STATE_IDX_BECOME_OLD,	/* Ϸ */

	STATE_IDX_REGENERATION,	/* ꥸ */
	STATE_IDX_INVINCIBLE,	/* ̵Ũ */
	STATE_IDX_SLOW,			/*  */
	STATE_IDX_HASTE,		/* إ */
	STATE_IDX_STOP,			/* ȥå */
	STATE_IDX_SHELL,		/*  */
	STATE_IDX_PROTECT,		/* ץƥ */
	STATE_IDX_REFLECT,		/* ե쥯 */

	STATE_IDX_HANGUP,		/* Ƥ */
	STATE_IDX_DEADLY,		/* λ */
	STATE_IDX_SINGING,		/* ΤäƤ */
	STATE_IDX_SLIP,			/* å */
	STATE_IDX_BECOME_DEATH,	/*  */
	STATE_IDX_REVERSE,		/* ȿž */
	STATE_IDX_FALSE_IMAGE,	/* ʪ */
	STATE_IDX_EXIT,			/* Υæ */

	NUM_STATE
};

enum
{
	STATE_IDX_FLIRT = 3 ,	/*  */
	STATE_IDX_JUMP,			/*  */
	STATE_IDX_GUARD = 6,	/* ޤ */
	STATE_IDX_DEFENSE,		/* ܤ */

	NUM_STATE_FLAG
};

enum
{
	MONTYPE_IDX_UNDEAD,		/* ǥå */
	MONTYPE_IDX_UNKNOWN,	/*  */
	MONTYPE_IDX_BEAST,		/*  */
	MONTYPE_IDX_AVIS,		/* ӥ */
	MONTYPE_IDX_DRAGON,		/* ɥ饴 */
	MONTYPE_IDX_BOSS,		/* ܥ */
	MONTYPE_IDX_DESERT,		/*  */
	MONTYPE_IDX_HUMAN,		/* ʹ */

	NUM_MONTYPE
};

#define ELEM_FIRE		(1U << ELEM_IDX_FIRE)
#define ELEM_ICE		(1U << ELEM_IDX_ICE)
#define ELEM_THUNDER	(1U << ELEM_IDX_THUNDER)
#define ELEM_POISON		(1U << ELEM_IDX_POISON)
#define ELEM_SACRED		(1U << ELEM_IDX_SACRED)
#define ELEM_EARTH		(1U << ELEM_IDX_EARTH)
#define ELEM_WIND		(1U << ELEM_IDX_WIND)
#define ELEM_WATER		(1U << ELEM_IDX_WATER)
#define ELEM_ALL		(ELEM_FIRE	| ELEM_ICE		| ELEM_THUNDER	| ELEM_POISON	| \
						ELEM_SACRED	| ELEM_EARTH	| ELEM_WIND		| ELEM_WATER)

#define CATEGORY_ENEMY		(1U << CATEGORY_IDX_ENEMY)
#define CATEGORY_WHITE		(1U << CATEGORY_IDX_WHITE)
#define CATEGORY_BLACK		(1U << CATEGORY_IDX_BLACK)
#define CATEGORY_TIME		(1U << CATEGORY_IDX_TIME)
#define CATEGORY_SUMMON		(1U << CATEGORY_IDX_SUMMON)
#define CATEGORY_WAVE		(1U << CATEGORY_IDX_WAVE)
#define CATEGORY_LONG		(1U << CATEGORY_IDX_LONG)
#define CATEGORY_SHORT		(1U << CATEGORY_IDX_SHORT)
#define CATEGORY_ALL		(CATEGORY_ENEMY	| CATEGORY_WHITE	| CATEGORY_BLACK	| CATEGORY_TIME	| \
							CATEGORY_SUMMON	| CATEGORY_WAVE		| CATEGORY_LONG		| CATEGORY_SHORT)

#define STATE_DARKNESS		(1U << STATE_IDX_DARKNESS)
#define STATE_ZOMBIE		(1U << STATE_IDX_ZOMBIE)
#define STATE_POISON		(1U << STATE_IDX_POISON)
#define STATE_LEVITATE		(1U << STATE_IDX_LEVITATE)
#define STATE_MINIMUM		(1U << STATE_IDX_MINIMUM)
#define STATE_TOAD			(1U << STATE_IDX_TOAD)
#define STATE_STONE			(1U << STATE_IDX_STONE)
#define STATE_SWOON			(1U << STATE_IDX_SWOON)
#define STATE_PERMANENT		(STATE_DARKNESS	| STATE_ZOMBIE	| STATE_POISON	| STATE_LEVITATE	| \
							STATE_MINIMUM	| STATE_TOAD	| STATE_STONE	| STATE_SWOON)

#define STATE_ILLUSION		(1U << STATE_IDX_ILLUSION)
#define STATE_ILLUSION_D	(1U << STATE_IDX_ILLUSION_D)
#define STATE_SILENT		(1U << STATE_IDX_SILENT)
#define STATE_BERSERK		(1U << STATE_IDX_BERSERK)
#define STATE_CONFUSE		(1U << STATE_IDX_CONFUSE)
#define STATE_PARALYZE		(1U << STATE_IDX_PARALYZE)
#define STATE_SLEEP			(1U << STATE_IDX_SLEEP)
#define STATE_BECOME_OLD	(1U << STATE_IDX_BECOME_OLD)
#define STATE_TEMPORARY		(STATE_ILLUSION	| STATE_ILLUSION_D	| STATE_SILENT	| STATE_BERSERK	| \
							STATE_CONFUSE	| STATE_PARALYZE	| STATE_SLEEP	| STATE_BECOME_OLD)

#define STATE_REGENERATION	(1U << STATE_IDX_REGENERATION)
#define STATE_INVINCIBLE	(1U << STATE_IDX_INVINCIBLE)
#define STATE_SLOW			(1U << STATE_IDX_SLOW)
#define STATE_HASTE			(1U << STATE_IDX_HASTE)
#define STATE_STOP			(1U << STATE_IDX_STOP)
#define STATE_SHELL			(1U << STATE_IDX_SHELL)
#define STATE_PROTECT		(1U << STATE_IDX_PROTECT)
#define STATE_REFLECT		(1U << STATE_IDX_REFLECT)
#define STATE_ASSISTMAG		(STATE_REGENERATION	| STATE_INVINCIBLE	| STATE_SLOW	| STATE_HASTE	| \
							STATE_STOP			| STATE_SHELL		| STATE_PROTECT	| STATE_REFLECT)

#define STATE_HANGUP		(1U << STATE_IDX_HANGUP)
#define STATE_DEADLY		(1U << STATE_IDX_DEADLY)
#define STATE_SINGING		(1U << STATE_IDX_SINGING)
#define STATE_SLIP			(1U << STATE_IDX_SLIP)
#define STATE_BECOME_DEATH	(1U << STATE_IDX_BECOME_DEATH)
#define STATE_REVERSE		(1U << STATE_IDX_REVERSE)
#define STATE_FALSE_IMAGE	(1U << STATE_IDX_FALSE_IMAGE)
#define STATE_EXIT			(1U << STATE_IDX_EXIT)
#if 0
#define STATE_OTHER			(STATE_HANGUP		| STATE_DEADLY		| STATE_SINGING		| STATE_SLIP	| \
							STATE_BECOME_DEATH	| STATE_REVERSE		| STATE_FALSE_IMAGE	| STATE_EXIT)
#else
#define STATE_OTHER			(STATE_DEADLY | STATE_SLIP | STATE_BECOME_DEATH | STATE_FALSE_IMAGE | STATE_EXIT)
#endif /* 0 */

#define STATE_ALL			(STATE_PERMANENT | STATE_TEMPORARY | STATE_ASSISTMAG | STATE_OTHER)

#define STATE_FLIRT			(1U << STATE_IDX_FLIRT)
#define STATE_JUMP			(1U << STATE_IDX_JUMP)
#define STATE_GUARD			(1U << STATE_IDX_GUARD)
#define STATE_DEFENSE		(1U << STATE_IDX_DEFENSE)
#define STATE_FLAG			(STATE_FLIRT | STATE_JUMP | STATE_GUARD | STATE_DEFENSE)

#define MONTYPE_UNDEAD		(1U << MONTYPE_IDX_UNDEAD)
#define MONTYPE_UNKNOWN		(1U << MONTYPE_IDX_UNKNOWN)
#define MONTYPE_BEAST		(1U << MONTYPE_IDX_BEAST)
#define MONTYPE_AVIS		(1U << MONTYPE_IDX_AVIS)
#define MONTYPE_DRAGON		(1U << MONTYPE_IDX_DRAGON)
#define MONTYPE_BOSS		(1U << MONTYPE_IDX_BOSS)
#define MONTYPE_DESERT		(1U << MONTYPE_IDX_DESERT)
#define MONTYPE_HUMAN		(1U << MONTYPE_IDX_HUMAN)
#if 0
#define MONTYPE_ALL			(MONTYPE_UNDEAD	| MONTYPE_UNKNOWN	| MONTYPE_BEAST		| MONTYPE_AVIS	| \
							MONTYPE_DRAGON	| MONTYPE_BOSS		| MONTYPE_DESERT	| MONTYPE_HUMAN)
#else
#define MONTYPE_ALL			(MONTYPE_UNDEAD	| MONTYPE_BEAST		| MONTYPE_AVIS	| \
							MONTYPE_DRAGON	| MONTYPE_BOSS		| MONTYPE_DESERT	| MONTYPE_HUMAN)
#endif /* 0 */

typedef unsigned char elem_t;
typedef unsigned char category_t;
typedef unsigned long state_t;
typedef unsigned char montype_t;

const char *str_getflag(int flag);
const char *str_getelem(elem_t elem, int index);
char *str_setelem(char *str, elem_t elem, size_t bufsize);
void str_printelem(FILE *stream, elem_t elem, elem_t elem_mask);
const char *str_getcategory(category_t category, int index);
char *str_setcategory(char *str, category_t category, size_t bufsize);
void str_printcategory(FILE *stream, category_t category, category_t category_mask);
const char *str_getstate(state_t state, int index);
char *str_setstate(char *str, state_t state, size_t bufsize);
char *str_setstate_f(char *str, state_t state, size_t bufsize);
void str_printstate(FILE *stream, state_t state, state_t state_mask);
const char *str_getmontype(montype_t montype, int index);
void str_printmontype(FILE *stream, montype_t montype, montype_t montype_mask);

#define bits_make32(byte1, byte2, byte3, byte4)	( ((byte1) & 0xff) | \
												( ((byte2) & 0xff) <<  8) | \
												( ((byte3) & 0xff) << 16) | \
												( ((byte4) & 0xff) << 24))

#define MAX(a, b)		((a > b) ? (a) : (b))
#define MIN(a, b)		((a < b) ? (a) : (b))

#define STR_NOTHING		""
#define STR_NOTHING_8	"--------"
#define STR_NOTHING_10	"----------"
#define STR_NOTHING_16	"----------------"
#define STR_NOTHING_18	"------------------"

#endif /* FF5DEFINE_H */
