/*
 *	ff5item.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5ITEM_H)
#define FF5ITEM_H

#include "ff5define.h"
#include "ff5character.h"
#include "ff5magic.h"

typedef magdata_t tooldata_t;

typedef struct weapon_tag
{
	tooldata_t data;				/* ˡǡ */
	chrparam_t increase;			/* ơ徺 */

	int attack_power;				/*  */
	int using_effect_no;			/* ѻθ */
	int additional_effect_rate;		/* ɲø̤ȯưΨ */
	int additional_effect_no;		/* ɲø */

	int equip_type;					/* ʤμ */
	elem_t elem_powerup;			/* ѥåפ° */

	int flag_reflect;				/* ե쥯ȿͲǽ */
	int flag_break;					/* ѤȲ */
	int flag_throw;					/* ꤲ */
	int flag_enchant;				/* ˡ */
	int flag_evade;					/* ʪǤ(1) */
	int flag_evade_f;				/* ʪǤ(2) */
	int flag_wonder_wand;			/* () */
	int flag_additional_effect;		/* ɲø̤(̾ﹶθ)ȯư */
	int flag_additional_effect_r;	/* ɲø̤(̾ﹶä)ȯư */
	int flag_initiative;			/* ǽ˹Ǥ */
	int flag_2handed;				/* ξǤ */
	int flag_2handed_f;				/* ξ */
	int flag_backrow;				/* 󤫤ǤϤ㲼ʤ */
	int flag_magic_attack;			/* ˡϤι */
} weapon_t;

typedef struct protector_tag
{
	int defense_power;			/* ɸ */
	int evade_rate;				/* Ψ */
	int magic_defense_power;	/* ˡɸ */
	int magic_evade_rate;		/* ˡΨ */
	int weight;					/*  */
	chrparam_t increase;		/* ơ徺 */

	int protector_type;			/* ɶμ */
	int equip_type;				/* ʤμ */
	elem_t elem_half;			/* Ⱦ° */
	elem_t elem_none;			/* ̵° */
	elem_t elem_evade;			/* ° */
	elem_t elem_absorb;			/* ۼ° */
	elem_t elem_double;			/* ° */
	elem_t elem_powerup;		/* ѥåפ° */
	state_t state_defense;		/* Ѳؤ */
	state_t state_apriori;		/* ǽ餫ŬѤѲ */
	int flag_evade;				/* ʪǤ */
	int flag_magic_evade;		/* ˡǤ */
	int flag_steal;				/* ߤ䤹ʤ */
	int flag_capture;			/* ͤ䤹ʤ */
	int flag_monk_fight;		/* ֤Ȥפθ̤Ĥ */
	int flag_mp_half;			/* ƮξޥåݥȤȾʬˤʤ */
	int flag_sword_dance;		/* ֤Ĥ뤮ΤޤפФ䤹ʤ */
	int flag_undead;			/* ǥåɤĤ */
} protector_t;

typedef struct tool_tag
{
	tooldata_t data;			/* ˡǡ */

	int flag_throw;				/* ꤲ */
	int flag_tool;				/* ƥȤƻѤǤ */
	int flag_drink;				/*  */
	int flag_magic_lamp;		/* ƥȤƲ٤ǤѤǤ */
	int flag_mix;				/* ĴǤ */
} tool_t;

union itemparam_t
{
	weapon_t weapon;		/* 異ƥǡ */
	protector_t protector;	/* ɶ񥢥ƥǡ */
	tool_t tool;			/* ƥǡ */
};

enum item_type	/* itemdata_tag.type */
{
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_PROTECTOR,	/* ɶ */
	ITEM_TYPE_TOOL			/* ƥ */
};

typedef struct itemdata_tag
{
	enum item_type type;		/* (ITEM_TYPE_WEAPONITEM_TYPE_TOOL) */
	long price_buy;				/*  */
	long price_sell;			/*  */
	int message_no;				/* åֹ */
	union itemparam_t param;	/* ƥǡ */
} itemdata_t;

const char *item_getname(int index);
const char *item_getequiptype(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelem(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writecategory(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestate(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeflag(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeparambug(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelembug(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestatbug(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeflagbug(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* FF5ITEM_H */
