/*
 *	ff5map.c
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "file.h"
#include "ff5decode.h"
#include "ff5map.h"

#define FILEPOS_MAPDATA				0x136ca8	/* SNES: 0x0e9c00 */
#define NUM_MAP_EVENT				1029
#define NUM_MAP_OBJECT				2386
#define NUM_MAP_MOVE				1385
#define SIZEOF_MAPDATA				28
#define MSGID_MAPNAME				3917

/* ޥåѥǡ */
#define FILEPOS_MAP_MONENC				0x13b0fc	/* SNES: 0x108000 */
#define FILEPOS_MAP_ENCRATE				0x13b540	/* SNES: 0x108400 */
#define FILEPOS_MAP_EVENT				0x3c7354	/* SNES: 0x0e2800 */
#define FILEPOS_MAP_OBJECT				0x3c0a5c	/* SNES: 0x0e5dc2 */
#define FILEPOS_MAP_MOVE				0x13d414	/* SNES: 0x0e3ac0 */
#define FILEPOS_MAP_EVENT_OFFSET		0x3c6f0c	/* SNES: 0x0e2400 */
#define FILEPOS_MAP_OBJECT_OFFSET		0x3c0614	/* SNES: 0x0e59c0 */
#define FILEPOS_MAP_MOVE_OFFSET			0x13cfcc	/* SNES: 0x0e36c0 */
#define FILEPOS_MAP_TREASURE_OFFSET		0x142100
#define SIZEOF_MAP_MONENC				2
#define SIZEOF_MAP_EVENT				4
#define SIZEOF_MAP_OBJECT				7
#define SIZEOF_MAP_MOVE					12			/* SNES: 6 */
#define SIZEOF_MAPPOS_OFFSET			2

static void map_setname(void);

static char tbl_mapname[NUM_MAP][256];			/* ޥåפ̾Ǽơ֥ */
static int flag_setmapname = 0;					/* tbl_mapname˥ǡǼƤ뤫ɤ */

const char *map_getname(int index)
{
	/* å */
	if (index < 0 || NUM_MAP <= index)
	{
		assert(0);
		return "";
	}

	/* ơ֥ͤꤵƤʤϡͤꤹ */
	if (!flag_setmapname)
		map_setname();

	return tbl_mapname[index];
}

static void map_setname(void)
{
	int i;
	char *ptr;

	/* ޥåפ̾ǡ */
	for (i = 0; i < NUM_MAP; i++)
		*tbl_mapname[i] = '\0';

	/* ޥåפ̾ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		dec_msg(tbl_mapname[i], sizeof(tbl_mapname[i]), MSGID_MAPNAME + i, FLAG_KANA);

		/* Ԥ򵭹֤ */
		while ((ptr = strchr(tbl_mapname[i], '\n')) != NULL)
			*ptr = ' ';
	}

	flag_setmapname = 1;
}

mapdata_t *map_readdata(void)
{
	int i;
	mapdata_t *buf_mapdata = NULL;
	int tbl_offset_ev[NUM_MAP + 1];
	int tbl_offset_obj[NUM_MAP + 1];
	int tbl_offset_move[NUM_MAP + 1];
	int tbl_offset_tr[NUM_MAP + 1];

	/* ޥåץǡǼХåեݤ */
	if ((buf_mapdata = malloc(sizeof(mapdata_t) * NUM_MAP)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ޥåץǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		unsigned char buf[SIZEOF_MAPDATA];

		file_read(buf, FILEPOS_MAPDATA + SIZEOF_MAPDATA * i, SIZEOF_MAPDATA);

		/* ͷϥǡ */
		buf_mapdata[i].id             = (buf[1] << 8) | buf[0];
		buf_mapdata[i].background_no  = buf[24];
		buf_mapdata[i].music_no       = buf[25];

		/* ե饰ϥǡ */
		buf_mapdata[i].flag_encounter = ((buf[6] & 0x80) != 0x00);
	}

	/* 󥹥ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		unsigned char buf[SIZEOF_MAP_MONENC];

		file_read(buf, FILEPOS_MAP_MONENC + SIZEOF_MAP_MONENC * i, SIZEOF_MAP_MONENC);
		buf_mapdata[i].enc_no = (buf[1] << 8) | buf[0];
	}

	/* ֥ǡǼƤ륢ɥ쥹(ؤΥեå)ɤ߹ */
	for (i = 0; i < NUM_MAP + 1; i++)
	{
		unsigned char buf[SIZEOF_MAPPOS_OFFSET];

		file_read(buf, FILEPOS_MAP_EVENT_OFFSET    + SIZEOF_MAPPOS_OFFSET * i, SIZEOF_MAPPOS_OFFSET);
		tbl_offset_ev[i]   = (buf[1] << 8) | buf[0];

		file_read(buf, FILEPOS_MAP_OBJECT_OFFSET   + SIZEOF_MAPPOS_OFFSET * i, SIZEOF_MAPPOS_OFFSET);
		tbl_offset_obj[i]  = (buf[1] << 8) | buf[0];

		file_read(buf, FILEPOS_MAP_MOVE_OFFSET     + SIZEOF_MAPPOS_OFFSET * i, SIZEOF_MAPPOS_OFFSET);
		tbl_offset_move[i] = (buf[1] << 8) | buf[0];

		file_read(buf, FILEPOS_MAP_TREASURE_OFFSET + SIZEOF_MAPPOS_OFFSET * i, SIZEOF_MAPPOS_OFFSET);
		tbl_offset_tr[i]   = (buf[1] << 8) | buf[0];
	}

	/* ٥Ȥ֥ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int tbl_this = tbl_offset_ev[i];
		const int tbl_next = tbl_offset_ev[i + 1];

		assert((tbl_this - 0x448) % SIZEOF_MAP_EVENT == 0);	/*  */

		buf_mapdata[i].event_id  = (tbl_this - 0x448) / SIZEOF_MAP_EVENT;
		buf_mapdata[i].event_num = (tbl_next - tbl_this) / SIZEOF_MAP_EVENT;
	}

	/* ֥Ȥ֥ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int tbl_this = tbl_offset_obj[i];
		const int tbl_next = tbl_offset_obj[i + 1];

		assert((tbl_this - 0x448) % SIZEOF_MAP_OBJECT == 0);	/*  */

		buf_mapdata[i].object_id  = (tbl_this - 0x448) / SIZEOF_MAP_OBJECT;
		buf_mapdata[i].object_num = (tbl_next - tbl_this) / SIZEOF_MAP_OBJECT;
	}

	/* ư֥ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int tbl_this = tbl_offset_move[i];
		const int tbl_next = tbl_offset_move[i + 1];

		buf_mapdata[i].move_id  = tbl_this;
		buf_mapdata[i].move_num = tbl_next - tbl_this;
	}

	/* Ȣ֥ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int tbl_this = tbl_offset_tr[i];
		const int tbl_next = tbl_offset_tr[i + 1];

		buf_mapdata[i].treasure_id  = tbl_this;
		buf_mapdata[i].treasure_num = tbl_next - tbl_this;
	}

	return buf_mapdata;
}

#if 0
mapevent_t *map_readevent(const mapdata_t *ptr_mapdata)
{
	int i;
	mapevent_t *buf_mapevent = NULL;

	/* ٥ȤγƼǡǼХåեݤ */
	if ((buf_mapevent = malloc(sizeof(mapevent_t) * NUM_MAP_EVENT)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ٥ȤγƼǡɤ߹ */
	for (i = 0; i < NUM_MAP_EVENT; i++)
	{
		unsigned char buf[SIZEOF_MAP_EVENT];

		file_read(buf, FILEPOS_MAP_EVENT + SIZEOF_MAP_EVENT * i, SIZEOF_MAP_EVENT);

		/* ͷϥǡ */
		buf_mapevent[i].map.id   = 0;	/* Τ */
		buf_mapevent[i].map.x    = buf[0];
		buf_mapevent[i].map.y    = buf[1];
		buf_mapevent[i].event_id = (buf[3] << 8) | buf[2];
	}

	/* ٥Ȥ֥ǡɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int index = ptr_mapdata[i].event_id;
		int num = ptr_mapdata[i].event_num;

		assert(index + num <= NUM_MAP_EVENT);

		if (num > 0 && index + num <= NUM_MAP_EVENT)
		{
			for (; num > 0; num--)
				buf_mapevent[index + num - 1].map.id = ptr_mapdata[i].id;
		}
	}

	return buf_mapevent;
}

mapobject_t *map_readobject(const mapdata_t *ptr_mapdata)
{
	int i;
	mapobject_t *buf_mapobject = NULL;

	/* ֥ȤγƼǡǼХåեݤ */
	if ((buf_mapobject = malloc(sizeof(mapobject_t) * NUM_MAP_OBJECT)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ֥ȤγƼǡɤ߹ */
	for (i = 0; i < NUM_MAP_OBJECT; i++)
	{
		unsigned char buf[SIZEOF_MAP_OBJECT];

		file_read(buf, FILEPOS_MAP_OBJECT + SIZEOF_MAP_OBJECT * i, SIZEOF_MAP_OBJECT);

		/* ͷϷϥǡ */
		buf_mapobject[i].map.id     = 0;	/* Τ */
		buf_mapobject[i].map.x      = buf[3];
		buf_mapobject[i].map.y      = buf[4];
		buf_mapobject[i].event_id   = (buf[1] & 0x3f << 8) | buf[0];	/*  */
		buf_mapobject[i].graphic_id = buf[2];
		buf_mapobject[i].move_type  = buf[5];
		buf_mapobject[i].direction  = buf[6];
	}

	/* ֥Ȥ֥ǡ (map.id) ɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int index = ptr_mapdata[i].object_id;
		int num = ptr_mapdata[i].object_num;

		assert(index + num <= NUM_MAP_OBJECT);

		if (num > 0 && index + num <= NUM_MAP_OBJECT)
		{
			for (; num > 0; num--)
				buf_mapobject[index + num - 1].map.id = ptr_mapdata[i].id;
		}
	}

	return buf_mapobject;
}

mapmove_t *map_readmove(const mapdata_t *ptr_mapdata)
{
	int i;
	mapmove_t *buf_mapmove = NULL;

	/* ưǡǼХåեݤ */
	if ((buf_mapmove = malloc(sizeof(mapmove_t) * NUM_MAP_MOVE)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ưǡɤ߹ */
	for (i = 0; i < NUM_MAP_MOVE; i++)
	{
		unsigned char buf[SIZEOF_MAP_MOVE];

		file_read(buf, FILEPOS_MAP_MOVE + SIZEOF_MAP_MOVE * i, SIZEOF_MAP_MOVE);

		/* ͷϥǡ */
		buf_mapmove[i].map.id     = 0;	/* Τ */
		buf_mapmove[i].map.x      = buf[0];
		buf_mapmove[i].map.y      = buf[1];
		buf_mapmove[i].move_to.id = (buf[3] << 8) | buf[2];
		buf_mapmove[i].move_to.x  = buf[7];
		buf_mapmove[i].move_to.y  = buf[8];
		buf_mapmove[i].direction  = buf[6];

		/* ե饰ϥǡ */
		buf_mapmove[i].flag_mapname = buf[4] ? 1 : 0;
		buf_mapmove[i].bits_vfx     = buf[5];
	}

	/* ưǡ֥ǡ (map.id) ɤ߹ */
	for (i = 0; i < NUM_MAP; i++)
	{
		const int index = ptr_mapdata[i].move_id;
		int num = ptr_mapdata[i].move_num;

		assert(index + num <= NUM_MAP_MOVE);

		if (num > 0 && index + num <= NUM_MAP_MOVE)
		{
			for (; num > 0; num--)
				buf_mapmove[index + num - 1].map.id = ptr_mapdata[i].id;
		}
	}

	return buf_mapmove;
}

int map_writedata(const char *ptr_filename, const mapdata_t *ptr_mapdata,
	const mapevent_t *ptr_mapevent, const mapobject_t *ptr_mapobject, const mapmove_t *ptr_mapmove)
{
	int i, j;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_mapdata == NULL ||
		ptr_mapevent == NULL || ptr_mapobject == NULL || ptr_mapmove == NULL)
	{
		assert(0);
		return 0;
	}

	/* ޥåץǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ޥåץǡϤ */
	for (i = 0; i < NUM_MAP; i++)
	{
		if (i != 0)
			fputc('\n', fp);

		fprintf(fp, "[No.%03d(%03X): %s]\n",
				i, i, map_getname(ptr_mapdata[i].id));

		fprintf(fp, "Ʈط:    %3d(%03X)\n", ptr_mapdata[i].background_no, ptr_mapdata[i].background_no);
		fprintf(fp, ":        %3d(%03X)\n", ptr_mapdata[i].music_no, ptr_mapdata[i].music_no);

		if (ptr_mapdata[i].flag_encounter)
			fprintf(fp, "Ũѡƥ:  %3d(%03X)\n", ptr_mapdata[i].enc_no, ptr_mapdata[i].enc_no);

		if (ptr_mapdata[i].event_num > 0)
		{
			const int index = ptr_mapdata[i].event_id;

			fprintf(fp, "٥:\n"
						" No.            x    y   ٥ID\n");
			for (j = 0; j < ptr_mapdata[i].event_num; j++)
			{
				fprintf(fp, " - %4d(%03X): %3d, %3d : %4d(%03X)\n", index + j, index + j,
						ptr_mapevent[index + j].map.x,
						ptr_mapevent[index + j].map.y,
						ptr_mapevent[index + j].event_id, ptr_mapevent[index + j].event_id);
			}
		}

		if (ptr_mapdata[i].object_num > 0)
		{
			const int index = ptr_mapdata[i].object_id;

			fprintf(fp, "֥:\n"
						" No.            x    y   ٥ID\n");
			for (j = 0; j < ptr_mapdata[i].object_num; j++)
			{
				fprintf(fp, " - %4d(%03X): %3d, %3d : %4d(%03X)\n", index + j, index + j,
						ptr_mapobject[index + j].map.x,
						ptr_mapobject[index + j].map.y,
						ptr_mapobject[index + j].event_id, ptr_mapobject[index + j].event_id);
			}
		}

		if (ptr_mapdata[i].move_num > 0)
		{
			const int index = ptr_mapdata[i].move_id;

			fprintf(fp, "ư:\n"
						" No.            x    y   ư                                 ID       x    y\n");
			for (j = 0; j < ptr_mapdata[i].move_num; j++)
			{
				fprintf(fp, " - %4d(%03X): %3d, %3d : %-38s (%03X), %3d, %3d\n", index + j, index + j,
						ptr_mapmove[index + j].map.x,
						ptr_mapmove[index + j].map.y,
						map_getname(ptr_mapmove[index + j].move_to.id),
						ptr_mapmove[index + j].move_to.id,
						ptr_mapmove[index + j].move_to.x,
						ptr_mapmove[index + j].move_to.y);
			}
		}

		if (ptr_mapdata[i].treasure_num > 0)
		{
			const int index = ptr_mapdata[i].treasure_id;

			fprintf(fp, "Ȣ:\n");
			for (j = 0; j < ptr_mapdata[i].treasure_num; j++)
			{
				fprintf(fp, " - %4d(%03X)\n", index + j, index + j);
			}
		}
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
#endif
