/*
 *	ff5map.h
 *		Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5MAP_H)
#define FF5MAP_H

#include "ff5define.h"

#define NUM_MAP		547		/* SNES: 512 */

typedef struct mappos_tag
{
	int id;					/* ޥå ID */
	size_t x;				/* X ɸ */
	size_t y;				/* Y ɸ */
} mappos_t;

typedef struct mapdata_tag
{
	int id;					/* ޥå ID */
	int flag_encounter;		/* 󥹥 */
	int enc_no;				/* 󥹥ơֹ֥ */
	int background_no;		/* Ʈط */
	int music_no;			/*  */
	int event_id;			/* ٥ȤؤΥեå */
	int event_num;			/* ٥Ȥο */
	int object_id;			/* ֥ȤؤΥեå */
	int object_num;			/* ֥Ȥο */
	int move_id;			/* ưؤΥեå */
	int move_num;			/* ưο */
	int treasure_id;		/* ȢؤΥեå */
	int treasure_num;
} mapdata_t;

typedef struct mapevent_tag
{
	int event_id;				/* ٥ֹ */
	mappos_t map;				/* ޥå׺ɸ */
} mapevent_t;

typedef struct mapobject_tag
{
	int event_id;				/* ٥ֹ */
	int graphic_id;				/* 饯ֹ */
	mappos_t map;				/* ޥå׺ɸ */
	int move_type;				/* ԥ */
	int direction;				/*  */
} mapobject_t;

typedef struct mapmove_tag
{
	mappos_t map;				/* ޥå׺ɸ */
	mappos_t move_to;			/* ưޥå׺ɸ */
	int direction;				/* ưθ */
	int flag_mapname;			/* ư̾ɽ뤫 */
	unsigned char bits_vfx;		/* и */
} mapmove_t;

const char *map_getname(int index);
mapdata_t *map_readdata(void);
mapevent_t *map_readevent(const mapdata_t *ptr_mapdata);
mapobject_t *map_readobject(const mapdata_t *ptr_mapdata);
mapmove_t *map_readmove(const mapdata_t *ptr_mapdata);
int map_writedata(const char *ptr_filename, const mapdata_t *ptr_mapdata, const mapevent_t *ptr_mapevent, const mapobject_t *ptr_mapobject, const mapmove_t *ptr_mapmove);

#endif /* FF5MAP_H */
