/*
 *	ff5misc.h
 *		Copyright (C)2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5MISC_H)
#define FF5MISC_H

#include "ff5define.h"
#include "ff5map.h"
#include "ff5monster.h"
#include "ff5item.h"

#define NUM_STORE_ITEM		8

enum treasure_type	/* treasure_tag.type */
{
	TREASURE_TYPE_GIL,		/*  */
	TREASURE_TYPE_MAGIC,	/* ˡ */
	TREASURE_TYPE_ITEM,		/* ƥ */
	TREASURE_TYPE_NUM
};

enum store_type	/* store_tag.type */
{
	STORE_TYPE_MAGIC,		/* ˡ */
	STORE_TYPE_ITEM,		/* ﲰɶ񲰡ƻ񲰡ꡦɡ */
	STORE_TYPE_NUM
};

typedef struct treasure_tag
{
	enum treasure_type type;	/* (TREASURE_TYPE_GILTREASURE_TYPE_MAGIC) */
	union
	{
		long gil;				/*  */
		int magic_no;			/* Ǥˡֹ */
		int item_no;			/* Ǥ륢ƥֹ */
	} param;

	int monster_no;				/* и󥹥ơֹ֥ */
	mappos_t map;				/* ޥå׺ɸ */
} treasure_t;

typedef struct store_tag
{
	enum store_type type;		/*  */
	int type_no;				/*  */
	int flag_half;				/* 1/2 ʤǹǤ */
	union
	{
		int magic_no[NUM_STORE_ITEM];	/* Ǥˡֹ */
		int item_no[NUM_STORE_ITEM];	/* Ǥ륢ƥֹ */
	} param;
} store_t;

treasure_t *tr_readdata(const mapdata_t *ptr_mapdata);
store_t *store_readdata(void);
int tr_writedata(const char *ptr_filename, const treasure_t *ptr_trdata, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty, const mondata_t *ptr_mondata);
int store_writedata(const char *ptr_filename, const store_t *ptr_storedata, const itemdata_t *ptr_itemdata);

#endif /* FF5MISC_H */
