/*
 *	ff5monster.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#if !defined(FF5MONSTER_H)
#define FF5MONSTER_H

#include "ff5define.h"
#include "ff5map.h"

typedef struct mondata_tag
{
	int level;					/* ٥ */
	long hit_point;				/* ҥåȥݥ */
	long magic_point;			/* ޥåݥ */
	long experience_point;		/* и */
	long gil;					/*  */
	int speed;					/* ® */
	int stamina;				/*  */
	int attack_power;			/*  */
	int defense_power;			/* ɸ */
	int evade_rate;				/* Ψ */
	int magic_attack_power;		/* ˡ */
	int magic_defense_power;	/* ˡɸ */
	int magic_evade_rate;		/* ˡΨ */
	int weapon_no;				/* ̾ﹶ */
	int multiplier;				/* ᡼Ψ */
	int magic_multiplier;		/* ˡ᡼Ψ */
	int id;						/* ID */
	elem_t elem_none;			/* ̵° */
	elem_t elem_absorb;			/* ۼ° */
	elem_t elem_double;			/* ° */
	category_t category_weak;	/* ƥ */
	state_t state_defense;		/* Ѳؤ */
	state_t state_apriori;		/* ǽ餫ŬѤѲ */
	montype_t montype;			/* 󥹥 */
	int flag_capture;			/* ֤Ȥ館פǽ */
	int flag_control;			/* ֤Ĥפǽ */
	int flag_hide_hp;			/*	ҥåȥݥȤɽ򱣤 */
	int flag_tech_attack_up;	/* ֤Ȥ虜פ˹1.5ܸ̤ */
	int flag_tech_defence_down;	/* ֤Ȥ虜פɸ̵롦ǽ̤ */
	int flag_tech_become_old;	/* ֤Ȥ虜פ˽Ϸ̤ */
	int flag_tech_poison;		/* ֤Ȥ虜פǸ̤ */
	int flag_tech_darkness;		/* ֤Ȥ虜פ˰ŰǸ̤ */
	int flag_tech_paralyze;		/* ֤Ȥ虜פ̤ */
	int flag_tech_confuse;		/* ֤Ȥ虜פ˺̤ */
	int flag_tech_slip;			/* ֤Ȥ虜פ˥å׸̤ */
	int item_no[4];				/* ƥ */
	int control_no[4];			/* ֤Ĥפιư */
	int free_no;				/* ֤Ϥʤġפιư */
	int tech_no;				/* ֤Ȥ虜פιư */
} mondata_t;

typedef struct monact_tag
{
	int ptn_num;
	struct
	{
		size_t condition_size;		/* ŬѾǡΥХȿ */
		size_t action_size;			/* ưѥǡΥХȿ */
		unsigned char *condition;	/* ŬѾǡ */
		unsigned char *action;		/* ưѥǡ */
	} ptn[16];
} monact_t;

typedef struct monparty_tag
{
	int monster_no[8];			/* 󥹥μ */
	int position_x[8];			/* 󥹥 X ɸ */
	int position_y[8];			/* 󥹥 Y ɸ */
	int ability_point;			/* ӥƥݥ */
	int escape_rate;			/* ƨΤ䤹 */
	unsigned char bits_vfx;		/* Ū */
	unsigned char bits_exist;	/* Ʈϻ˥󥹥иƤ뤫 */
	unsigned char bits_backrow;	/* Ǥ */
	int music_no;				/* Ʈ */
	int flag_escape;			/* ƨǽǤ */
	int flag_boss_effect;		/* ƮλαФܥѤǤ */
	int flag_last_effect;		/* ƮλαФ饹ȥХȥѤǤ */
	int flag_magic;				/* ˡѲǽ */
	int flag_xleave;			/* Υæ֤Ǥи֥ե饰򥯥ꥢʤ */
	int flag_boss;				/* ܥȤƮǤ */
	int flag_mute;				/* ˡߥ塼ȤѲǽ */
	int flag_raid;				/* ɬХååǻϤޤ */
} monparty_t;

typedef struct monenc_tag
{
	int party_no[4];		/* 󥹥ѡƥμ */
} monenc_t;

typedef struct monmap_tag
{
	struct
	{
		int enc_no[4];
	} area[8][8];
} monmap_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monact_t *mon_readact(void);
monparty_t *mon_readparty(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeelem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writestate(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writefree(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writectrl(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writetech(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeweak(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const monact_t *ptr_monact, const mondata_t *ptr_mondata);
int mon_writemes(const char *ptr_filename);
int mon_writeparty(const char *ptr_filename, const monparty_t *ptr_monparty, const mondata_t *ptr_mondata);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty, const mondata_t *ptr_mondata);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);
int mon_writelocation(const char *ptr_filename, const mapdata_t *ptr_mapdata, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty, const mondata_t *ptr_mondata);
void mon_freeact(monact_t *ptr_monact);
void mon_printparty(FILE *stream, const monparty_t *monparty, const mondata_t *mondata);

#endif /* FF5MONSTER_H */
