/*
 *	ff5special.c
 *		Copyright (C)2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "file.h"
#include "ff5decode.h"
#include "ff5special.h"
#include "ff5item.h"

#define FILEPOS_SPDATA			0x149e24		/* SNES: 0x116ab1 */
#define FILEPOS_LANDSCAPE_TBL	0x149d24		/* SNES: 0x116df9 */
#define FILEPOS_MIX_PHARMACY	0x14b760		/* SNES: 0x116ef9 */
#define FILEPOS_MIX_COMBINE		0x12d02c
#define NUM_SP_ANIMAL			9				/* ɤ֤ */
#define NUM_SP_PHARMACY			64				/* 礦 */
#define NUM_SP_LANDSCAPE		24				/*  */
#define NUM_SP_DUMMY			8				/*  ߡ (̤) */
#define NUM_SP_PREDICTION		10				/* 褲 */
#define NUM_SP_PREDICTION_MP	4				/* 褲 ( MP) */
#define NUM_SP_COMBINE			48				/*  */
#define NUM_SP_CONDEMN			10				/* 󤳤 */
#define NUM_SP_OATH				4				/* ᤤ䤯 */
#define NUM_SP_FINISHER			3				/* Ҥä */
#define NUM_LANDSCAPE_TBL		64				/* Ϸơ֥ο */
#define NUM_ITEM_PHARMACY		12				/* ĴѤ륢ƥο */
#define NUM_ITEM_AMMO			3				/* Ѥο */
#define NUM_ITEM_COMBINE		(NUM_SP_COMBINE / NUM_ITEM_AMMO)	/* Ѥ륢ƥο */
#define NUM_MIX_PHARMACY		(NUM_ITEM_PHARMACY * NUM_ITEM_PHARMACY)
#define NUM_MIX_COMBINE			NUM_SP_COMBINE
#define NUM_MIX					(NUM_MIX_PHARMACY + NUM_MIX_COMBINE)
#define OFFSET_ITEM_PHARMACY	0xe0			/* ݡ */
#define OFFSET_SP_PHARMACY		0x00			/* ߥǥ */
#define OFFSET_SP_COMBINE		0x6b			/* ե쥤ॷå */
#define SIZEOF_SPDATA			8
#define SIZEOF_LANDSCAPE_TBL	4
#define SIZEOF_MIX_PHARMACY		1
#define SIZEOF_MIX_COMBINE		2
#define REGION_SP_ANIMAL_BEGIN			0
#define REGION_SP_ANIMAL_END			(REGION_SP_ANIMAL_BEGIN + NUM_SP_ANIMAL - 1)
#define REGION_SP_PHARMACY_BEGIN		(REGION_SP_ANIMAL_END + 1)
#define REGION_SP_PHARMACY_END			(REGION_SP_PHARMACY_BEGIN + NUM_SP_PHARMACY - 1)
#define REGION_SP_LANDSCAPE_BEGIN		(REGION_SP_PHARMACY_END + 1)
#define REGION_SP_LANDSCAPE_END			(REGION_SP_LANDSCAPE_BEGIN + NUM_SP_LANDSCAPE - 1)
#define REGION_SP_PREDICTION_BEGIN		(REGION_SP_LANDSCAPE_END + 1)
#define REGION_SP_PREDICTION_END		(REGION_SP_PREDICTION_BEGIN + NUM_SP_PREDICTION - 1)
#define REGION_SP_COMBINE_BEGIN			(REGION_SP_PREDICTION_END + 1)
#define REGION_SP_COMBINE_END			(REGION_SP_COMBINE_BEGIN + NUM_SP_COMBINE - 1)
#define REGION_SP_CONDEMN_BEGIN			(5 + REGION_SP_COMBINE_END + 1)
#define REGION_SP_CONDEMN_END			(REGION_SP_CONDEMN_BEGIN + NUM_SP_CONDEMN - 2 - 1)	/* -2 ̤ */
#define REGION_SP_PREDICTION_MP_BEGIN	(6 + REGION_SP_CONDEMN_END + 2 + 1)					/* +2 ̤ */
#define REGION_SP_PREDICTION_MP_END		(REGION_SP_PREDICTION_MP_BEGIN + NUM_SP_PREDICTION_MP - 1)
#define REGION_MIX_PHARMACY_BEGIN		0
#define REGION_MIX_PHARMACY_END			(REGION_MIX_PHARMACY_BEGIN + NUM_MIX_PHARMACY - 1)
#define REGION_MIX_COMBINE_BEGIN		(REGION_MIX_PHARMACY_END + 1)
#define REGION_MIX_COMBNIE_END			(REGION_MIX_COMBINE_BEGIN + NUM_MIX_COMBINE - 1)
#define NUM_SP					(REGION_SP_PREDICTION_MP_END + 1)	/* = 180 */
#define MSGID_SPNAME			5768
#define MSGID_SP_ANIMAL			MSGID_SPNAME											/* = 5768 */
#define MSGID_SP_PHARMACY		(MSGID_SP_ANIMAL + NUM_SP_ANIMAL)						/* = 5777 */
#define MSGID_SP_LANDSCAPE		(MSGID_SP_PHARMACY + NUM_SP_PHARMACY)					/* = 5841 */
#define MSGID_SP_COMBINE		(MSGID_SP_LANDSCAPE + NUM_SP_LANDSCAPE + NUM_SP_DUMMY)	/* = 5873 */
#define MSGID_SP_OATH			(MSGID_SP_COMBINE + NUM_SP_COMBINE)						/* = 5921 */
#define MSGID_SP_PREDICTION		(MSGID_SP_OATH + NUM_SP_OATH)							/* = 5925 */
#define MSGID_SP_FINISHER		(MSGID_SP_PREDICTION + NUM_SP_PREDICTION)				/* = 5935 */
#define MSGID_SP_CONDEMN		(MSGID_SP_FINISHER + NUM_SP_FINISHER)					/* = 5938 */
#define MSGID_SP_PREDICTION_MP	(MSGID_SPNAME - 777)									/* = 4991 */

static void sp_setname(void);

static char tbl_spname[NUM_SP][256];	/* ü칶̾Ǽơ֥ */
static int flag_setspname = 0;			/* tbl_spname˥ǡǼƤ뤫ɤ */

const char *sp_getname(int index)
{
	/* å */
	if (index < 0 || NUM_SP <= index)
	{
		assert(0);
		return "";
	}

	/* ơ֥ͤꤵƤʤϡͤꤹ */
	if (!flag_setspname)
		sp_setname();

	return tbl_spname[index];
}

static void sp_setname(void)
{
	int i = 0;

	/* ü칶̾ǡ */
	for (i = 0; i < NUM_SP; i++)
		*tbl_spname[i] = '\0';

	/* ü칶̾ǡɤ߹ */
	for (i = REGION_SP_ANIMAL_BEGIN; i <= REGION_SP_ANIMAL_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_ANIMAL - REGION_SP_ANIMAL_BEGIN + i, FLAG_KANA);

	for (i = REGION_SP_PHARMACY_BEGIN; i <= REGION_SP_PHARMACY_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_PHARMACY - REGION_SP_PHARMACY_BEGIN + i, FLAG_KANA);

	for (i = REGION_SP_LANDSCAPE_BEGIN; i <= REGION_SP_LANDSCAPE_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_LANDSCAPE - REGION_SP_LANDSCAPE_BEGIN + i, FLAG_KANA);

	for (i = REGION_SP_PREDICTION_BEGIN; i <= REGION_SP_PREDICTION_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_PREDICTION - REGION_SP_PREDICTION_BEGIN + i, FLAG_KANA);

	for (i = REGION_SP_COMBINE_BEGIN; i <= REGION_SP_COMBINE_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_COMBINE - REGION_SP_COMBINE_BEGIN + i, FLAG_KANA);

	for (i = REGION_SP_CONDEMN_BEGIN; i <= REGION_SP_CONDEMN_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_CONDEMN - REGION_SP_CONDEMN_BEGIN + i, FLAG_KANA);

	for (i = REGION_SP_PREDICTION_MP_BEGIN; i <= REGION_SP_PREDICTION_MP_END; i++)
		dec_msg(tbl_spname[i], sizeof(tbl_spname[i]), MSGID_SP_PREDICTION_MP - REGION_SP_PREDICTION_MP_BEGIN + i, FLAG_KANA);

	flag_setspname = 1;
}

spdata_t *sp_readdata(void)
{
	int i;
	spdata_t *buf_spdata = NULL;

	/* ü칶γƼǡǼХåեݤ */
	if ((buf_spdata = malloc(sizeof(spdata_t) * NUM_SP)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ü칶γƼǡɤ߹ */
	for (i = 0; i < NUM_SP; i++)
	{
		unsigned char buf[SIZEOF_SPDATA];

		file_read(buf, FILEPOS_SPDATA + SIZEOF_SPDATA * i, SIZEOF_SPDATA);
		mag_setparam(&buf_spdata[i], buf, sizeof(buf));
	}

	return buf_spdata;
}

landdata_t *sp_readland(void)
{
	int i, j;
	landdata_t *buf_landdata = NULL;

	/* Ϸθ̥ǡǼХåեݤ */
	if ((buf_landdata = malloc(sizeof(landdata_t) * NUM_LANDSCAPE_TBL)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	for (i = 0; i < NUM_LANDSCAPE_TBL; i++)
	{
		unsigned char buf[SIZEOF_LANDSCAPE_TBL];

		file_read(buf, FILEPOS_LANDSCAPE_TBL + SIZEOF_LANDSCAPE_TBL * i, SIZEOF_LANDSCAPE_TBL);
		for (j = 0; j < 4; j++)
			buf_landdata[i].effect_no[j] = buf[j];
	}

	return buf_landdata;
}

mixdata_t *sp_readmix(void)
{
	int i, j;
	int tbl_ammo[3];
	mixdata_t *buf_mixdata = NULL;

	/* ƥȤ߹碌γƼǡǼХåեݤ */
	if ((buf_mixdata = malloc(sizeof(mixdata_t) * NUM_MIX)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ֤礦פȤ߹碌ǡɤ߹ */
	for (i = 0; i < NUM_ITEM_PHARMACY; i++)
	{
		for (j = 0; j < NUM_ITEM_PHARMACY; j ++)
		{
			unsigned char buf[SIZEOF_MIX_PHARMACY];

			file_read(buf, FILEPOS_MIX_PHARMACY + SIZEOF_MIX_PHARMACY * (i * NUM_ITEM_PHARMACY + j), SIZEOF_MIX_PHARMACY);
			buf_mixdata[REGION_MIX_PHARMACY_BEGIN + i * NUM_ITEM_PHARMACY + j].item_no[0] = i + OFFSET_ITEM_PHARMACY;
			buf_mixdata[REGION_MIX_PHARMACY_BEGIN + i * NUM_ITEM_PHARMACY + j].item_no[1] = j + OFFSET_ITEM_PHARMACY;
			buf_mixdata[REGION_MIX_PHARMACY_BEGIN + i * NUM_ITEM_PHARMACY + j].effect_no  = buf[0] + OFFSET_SP_PHARMACY;
		}
	}

	/* ֤פǺȤʤΥǡɤ߹ */
	for (i = 0; i < NUM_ITEM_AMMO; i++)
	{
		unsigned char buf[SIZEOF_MIX_COMBINE];

		file_read(buf, FILEPOS_MIX_COMBINE + SIZEOF_MIX_COMBINE * i, SIZEOF_MIX_COMBINE);
		tbl_ammo[i] = (buf[1] << 8) | buf[0];
	}

	/* ֤פȤ߹碌ǡɤ߹ */
	for (i = 0; i < NUM_ITEM_COMBINE; i++)
	{
		unsigned char buf[SIZEOF_MIX_COMBINE];

		/* ֤פǺǡɤ߹ */
		file_read(buf, FILEPOS_MIX_COMBINE + SIZEOF_MIX_COMBINE * (i + NUM_ITEM_AMMO), SIZEOF_MIX_COMBINE);
		for (j = 0; j < NUM_ITEM_AMMO; j++)
		{
			buf_mixdata[REGION_MIX_COMBINE_BEGIN + i + j * NUM_ITEM_COMBINE].item_no[0] = tbl_ammo[j];
			buf_mixdata[REGION_MIX_COMBINE_BEGIN + i + j * NUM_ITEM_COMBINE].item_no[1] = (buf[1] << 8) | buf[0];
		}

		/* оݤȤʤ̤ɤ߹ */
		for (j = 0; j < NUM_ITEM_AMMO; j++)
		{
			const long filepos = FILEPOS_MIX_COMBINE + SIZEOF_MIX_COMBINE * (NUM_ITEM_AMMO + NUM_ITEM_COMBINE) + 0x02;

			file_read(buf, filepos + SIZEOF_MIX_COMBINE * (i + j * NUM_ITEM_COMBINE), SIZEOF_MIX_COMBINE);
			buf_mixdata[REGION_MIX_COMBINE_BEGIN + i + j * NUM_ITEM_COMBINE].effect_no = ((buf[1] << 8) | buf[0]) + OFFSET_SP_COMBINE;
		}
	}

	return buf_mixdata;
}

int sp_writeparam(const char *ptr_filename, const spdata_t *ptr_spdata)
{
	int i;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ü칶οͷϥǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ü칶οͷϥǡϤ */
	fprintf(fp, "No.       ̾                 "
				"MP    Ψ ̿Ψ   ³  "
				"Ի "
				"  \n");
	for (i = 0; i < NUM_SP; i++)
	{
		fprintf(fp, (ptr_spdata[i].effect_rate != 0) ?
					"%03d(%03X): %-18s :  %5d, %5d,%3d/16, %5d, %5d, %5d, %5d, %4Xh\n" :
					"%03d(%03X): %-18s :  %5d, %5d, %5d, %5d, %5d, %5d, %5d, %4Xh\n",
				i, i, sp_getname(i),
				ptr_spdata[i].magic_point,
				ptr_spdata[i].effect_power,
				ptr_spdata[i].effect_rate,
				ptr_spdata[i].hit_rate,
				ptr_spdata[i].effect_time,
				ptr_spdata[i].fixed_value,
				ptr_spdata[i].time_wait,
				ptr_spdata[i].effect_type);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}

int sp_writeelem(const char *ptr_filename, const spdata_t *ptr_spdata)
{
	int i;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ü칶°ϥǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ü칶°ϥǡϤ */
	fprintf(fp, "No.       ̾                 "
				"°\n");
	for (i = 0; i < NUM_SP; i++)
	{
		fprintf(fp, "%03d(%03X): %-18s : ", i, i, sp_getname(i));

		/* ° */
		str_printelem(fp, ptr_spdata[i].elem_effect, ELEM_ALL);
		fputc('\n', fp);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}

int sp_writecategory(const char *ptr_filename, const spdata_t *ptr_spdata)
{
	int i;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ü칶ΥƥǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ü칶ΥƥǡϤ */
	fprintf(fp, "No.       ̾                 "
				"ƥ\n");
	for (i = 0; i < NUM_SP; i++)
	{
		fprintf(fp, "%03d(%03X): %-18s : ", i, i, sp_getname(i));

		/* ƥ */
		str_printcategory(fp, ptr_spdata[i].category, CATEGORY_ALL);
		fputc('\n', fp);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}

int sp_writestate(const char *ptr_filename, const spdata_t *ptr_spdata)
{
	int i;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ü칶ξѲϥǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ü칶ξѲϥǡϤ */
	fprintf(fp, "No.       ̾                 "
				"Ѳ1        2                3                4\n");
	for (i = 0; i < NUM_SP; i++)
	{
		fprintf(fp, "%03d(%03X): %-18s : ", i, i, sp_getname(i));

		/* Ѳ */
		str_printstate(fp, ptr_spdata[i].state_effect, STATE_ALL);
		fputc('\n', fp);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}

int sp_writeflag(const char *ptr_filename, const spdata_t *ptr_spdata)
{
	int i;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_spdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ü칶Υե饰ϥǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ü칶Υե饰ϥǡϤ */
	fprintf(fp, "No.       ̾                 "
				"ȿ  "
				"ϰ           "
				"ͭ²\n");
	for (i = 0; i < NUM_SP; i++)
	{
		/* Ƽե饰 */
		fprintf(fp, "%03d(%03X): %-18s :  %2s   ", i, i, sp_getname(i),
				str_getflag(ptr_spdata[i].flag_reflect));

		/* ϰ */
		mag_printtarget(fp, &ptr_spdata[i]);

		/* ͭ󥹥 */
		if (ptr_spdata[i].montype_effect != 0x00)
		{
			fprintf(fp, "  ");
			str_printmontype(fp, ptr_spdata[i].montype_effect, MONTYPE_ALL);
		}

		fputc('\n', fp);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}

int sp_writeland(const char *ptr_filename, const landdata_t *ptr_landdata)
{
	int i, j;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_landdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* Ϸθ̥ǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* Ϸθ̥ǡϤ */
	fprintf(fp, "No.       LV1                 LV11                LV21                LV51\n");
	for (i = 0; i < NUM_LANDSCAPE_TBL; i++)
	{
		fprintf(fp, "%03d(%03X): ", i, i);

		for (j = 0; j < 4; j++)
		{
			if (j != 0)
				fprintf(fp, ", ");

			fprintf(fp, "%-18s",
				(j == 0 || ptr_landdata[i].effect_no[j] != ptr_landdata[i].effect_no[j - 1])
					? sp_getname(ptr_landdata[i].effect_no[j])
					: STR_NOTHING_18);
		}

		fputc('\n', fp);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}

int sp_writemix(const char *ptr_filename, const mixdata_t *ptr_mixdata)
{
	int i;
	FILE *fp = NULL;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_mixdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ƥȤ߹碌ǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ƥȤ߹碌ǡϤ */
	fprintf(fp, "No.       ̾                 "
				"Ǻ1               "
				"Ǻ2             \n");
	for (i = 0; i < NUM_MIX; i++)
	{
		fprintf(fp, "%03d(%03X): %-18s : %-18s, %-18s\n", i, i,
				sp_getname(ptr_mixdata[i].effect_no),
				item_getname(ptr_mixdata[i].item_no[0]),
				item_getname(ptr_mixdata[i].item_no[1]));
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
