/*
 *	ff6decode.c
 *		Copyright (C) 2007-2008 Inu
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "file.h"
#include "ff6decode.h"

#define FILEPOS_TEXTDATA_SHORT		0x1727fc
#define FILEPOS_TEXTDATA_LONG		0x17e518
#define NUM_MSGID_SHORT				2694
#define NUM_MSGID_LONG				6114
#define NUM_TEXTDATA_SHORT			NUM_MSGID_SHORT
#define NUM_TEXTDATA_LONG			(NUM_MSGID_LONG * 2)
#define SIZEOF_OFFSETADDR			4

#define Z(chr)	#chr				/* FULLWIDTH */

/* եʥե󥿥 VI ɥХ󥹤ʸɽ(˥塼) */
static const char *tbl_charcode[ 7][64] =
{
	/* 0xc0 */
	{
		"",   "",   "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "A",  "", " ", "", "", "", "", "", "",  "I",
		"", "", "", "O",  "", "", "", "", "", "", "", "", "", "", "", "T",
		"", "", "R",  "", "", "S",  "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xc1 */
	{
		"", "", "", "", "", "", "", "", "E",  "e",  "N",  "", "", "", "M",  "",
		"", "U",  "", "", "", "K" , "", "H",  "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "C",  "", "a",  "", "", "D",
		"1",  "", "", "", "", Z(?), "", "", "Y",  "r",  "", "n",  "", "", "h",  "t",
	},

	/* 0xc2 */
	{
		"", "", "", "", "", "", "L",  "", "", "", "o",  "G",  "", "", "", "",
		"", "", "", "P",  "", "", "0",  "s",  "i",  "", "", "", "", "", "", "",
		"", "", "l",  "", "+",  "d",  "", "c",  "", "2",  "5",  "", "", "", "m",  "W",
		"", "", "B",  "F",  "", "", "", "g",  "Q",  "", "", "/",  ":",  "%",  "", "Z",
	},

	/* 0xc3 */
	{
		"", "", "", "u",  "'",  "", "3",  "4",  "J",  "", "p",  ".",  "", Z(1), "V",  "f",
		"?",  "", Z(2), "k",  "", "8",  "", Z(!), "z",  "", "", "", "y",  "v",  "", Z(3),
		"", "", "X",  "w",  "--", "", "", "V",  Z(4), "", "", "", "", "", "6",  "7",
		"9",  "", "", "-",  Z(5), Z(0), "b",  "_",  ".",  ",",  "\"", "", "", "", Z(6), Z(7),
	},

	/* 0xc4 */
	{
		Z(8), "!",  "j",  "", "", "", "", "", "", "", "", "", "", "", "(",  ")",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "",  "(A)","(B)","(L)","(R)","", "", "", "", "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},

	/* 0xc5 */
	{
		"",   "", "", "", "", "", "", "", "", "", "", "", "", "#",  "$",  "",
		"(",  ")",  "", "", "", Z(9), "", "", "<",  "", ">",  "", "", "\\", "", "~",
		"~",  "1",  "", "{",  "\n", "}",  "", "",   "\n", "",   "",   "",   "",

		/* 򼨤楳(0xc5ad0xc680) */
		""/**/, ""/*û*/, ""/**/,
		""/**/, ""/**/, ""/**/, ""/*ɮ*/, ""/*΢*/, ""/*ꤲ*/, ""/**/, ""/**/,
		""/**/, ""/**/, ""/**/, ""/**/, ""/*ʪ*/, ""/**/, ""/*ˡ*/, ""/*ˡ*/,
	},

	/* 0xc6 */
	{
		/* 򼨤楳(0xc5ad0xc680) */
		""/*ˡ*/,

		/* 楳(0x81bf) */
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "%s", "%s", "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},
};

/* եʥե󥿥VIʸɽ(å) */
static const char *tbl_charcode_msg[29][64] =
{
	/* 0xc0 */
	{
		"  ", "",   "", "", "", "", "", "", "", "", "", "", "", Z(!), "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", Z(?), "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xc1 */
	{
		"", "", "", "", Z(0), "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", Z(1), "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "(",  ")",  "", "", "", "", "", "", "", "",
	},

	/* 0xc2 */
	{
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "ã", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", Z(2), "", "", "", Z(5), "", Z(3), "A",  "", "", "ʼ", "I",  " ",
		"", "", "", "", "ʬ", "", "ˡ", "", "", "O",  "", "", "", "", "", "",
	},

	/* 0xc3 */
	{
		"", "Ũ", "", "Ƴ", "S",  "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "Į", "", "̵", "", "", "", "", "", "U",  "", "", "", "",
		"", "", "ʪ", "ư", "", "R",  "", "T",  Z(4), "ɬ", "", "", "", "Ʈ", "", "̿",
		"", "", "Ĺ", "", "", "", "", "", "", "", Z(8), "", "", "", "H",  "E",
	},

	/* 0xc4 */
	{
		"", "", "", "", "ʹ", "", "", "", "", "°", "", "", "", "", "", "",
		"Ϸ", "Ʊ", "", "", "N",  "ƻ", "", "", "", "", "", "", Z(+), "r",  "", "",
		"", "", "e",  "K",  "", "", "", "", "", "", "", "", "", "", "ƨ", "ï",
		"", "ǯ", "", "", "", "Ω", "", "", "", "", "", "M",  "", "̼", "", "",
	},

	/* 0xc5 */
	{
		"", "", "¼", "", "", "ĥ", "̾", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "̴", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "Y",  "",
		"", "", "", "", "", "", "", "̣", "", "", "ʿ", "", "", "", "", "",
	},

	/* 0xc6 */
	{
		"", "", "", "", "Ϣ", "", "", "", "", "", "", "", "i",  "C",  "", "",
		"", "", "", "", "", "", "", "", "˾", "", "", "", "", "", "ľ", "³",
		"", "", "", "", "", "", "a",  Z(6), Z(7), "", "Ȣ", "", "", "", "ε", "",
		"", "", "", "ǽ", "", "", "", "", "", "", "", "m",  "g",  "ɹ", "", "",
	},

	/* 0xc7 */
	{
		"", "", "", "²", "", "", "ή", "", "", "", "", "", "", "", "", "",
		"ʢ", "", "", "", "", "", "", "ȯ", "", "ȴ", "©", "", "", "", "", "",
		"", "", "", "Φ", "", "", "", "", "n",  "s",  "G",  "D",  "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xc8 */
	{
		"¿", "", "", "õ", "", "c",  "o",  "p",  "F",  "P",  Z(9), "", "", "", "", "",
		"", "", "ʸ", "", "ɤ", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "ƶ", "", "", "",
		"", "", "", "", "", "", "̲", "", "", "", "", "", "ͥ", "", "", "d",
	},

	/* 0xc9 */
	{
		"t",  "", "­", "", "", "ȿ", "̩", "", "", "", "", "", "", "", "", "",
		"΢", "", "", "", "", "", "", "±", "ϴ", "", "¸", "", "", "", "", "",
		"", "", "", "", "V",  "", "", "", "ɽ", "", "", "", "", "", "Ϳ", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xca */
	{
		"", "", "", "", "", "", "Ƭ", "", "", "", "", "ͳ", "", "", "", "",
		"¾", "", "", "", "", "", "", "", "ʧ", "", "", "¤", "", "ŷ", "˽", "",
		"", "", "", "ú", "", "ͭ", "", "", "", "®", "", "˺", "", "", "", "",
		"Ǥ", "Ū", "æ", "", "", "", "", "", "«", "̤", "", "", "", "Ψ", "ʣ", "",
	},

	/* 0xcb */
	{
		"", "", "ι", "", "Ĵ", "", "", "ĺ", "", "", "", "ñ", "¹", "Ļ", "", "",
		"", "", "¨", "", "", "", "Ⱦ", "", "", "ξ", "", "", "", "", "", "",
		"", "", "1",  "", "", "", "", "", "", "", "", "", "", "", "", "",
		"̮", "", "ͧ", "", "", "", "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xcc */
	{
		"", "", "", "", "ĩ", "", "", "", "0",  "3",  "h",  "B",  "l",  "f",  "Ŵ", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "̱", "", "", "", "", "Υ", "", "", "", "", "", "",
		"", "", "", "", "", "ͷ", "", "", "", "", "ǰ", "", "", "", "", "",
	},

	/* 0xcd */
	{
		"", "", "", "", "", "", "", "", "", "", "", "", "·", "", "", "å",
		"", "", "", "", "", "", "", "", "", "ɴ", "", "", "ž", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "Ħ", ";", "Ǯ", "", "", "", "", "", "", "",
	},

	/* 0xce */
	{
		"", "ɸ", "", "", "", "Z",  "u",  "b",  "W",  "", "", "", "ť", "", "", "",
		"", "ͦ", "", "", "", "", "", "", "", "", "", "", "", "", "", "Ϻ",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "ü", "",
		"", "", "", "", "", "", "", "ͽ", "˫", "", "¦", "", "", "", "", "",
	},

	/* 0xcf */
	{
		"", "", "", "", "", "", "", "", "", "ķ", "", "ζ", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "γ", "", "", "", "", "", "",
		"", "", "", "", "ű", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	},

	/* 0xd0 */
	{
		"£", "", "", "", "", "", "", "", "ˬ", "", "", "", "Ķ", "", "û", "",
		"", "", "", "", "'",  "\"", "k",  "", "", "", "v",  "j",  "X",  "J",  "L",  "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "Ʒ", "", "", "", "į", "", "", "", "", "", "", "Ƨ", "á", "", "",
	},

	/* 0xd1 */
	{
		"", "", "é", "", "", "", "", "϶", "", "", "", "", "", "", "", "Ź",
		"", "", "", "", "", "", "", "", "", "", "", "", "ɡ", "ë", "", "",
		"", "", "ͩ", "", "", "", "", "", "", "", "", "Ǧ", "", "", "", "",
		"", "", "", "", "", "", "", "ά", "", "", "", "", "", "", "", "",
	},

	/* 0xd2 */
	{
		"ɮ", "ö", "", "̨", "", "Ư", "", "", "ǧ", "", "", "ê", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "(A)","(B)","(L)",
		"(R)","", "", "", "", "", "", "", "", "", "ˤ", "?",  "", "", "", "",
		"", "", "", "", "", "", "", "Ӭ", "", "", "", "", "", "", "", "ĳ",
	},

	/* 0xd3 */
	{
		"", "", "˱", "̽", "", "", "ϵ", "", "", "", "", "Ĩ", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "İ", "",
		"", "", "", "ȩ", "", "", "", "", "", "", "", "", "", "ͣ", "", "",
	},

	/* 0xd4 */
	{
		"", "", "", "", "", "", "", "ƽ", "", "", "", "", "", "", "", "",
		"Ǻ", "", "", "", "Ÿ", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "Ģ", "", "", "ȳ", "", "Ǽ", "", "κ", "",
		"", "", "ī", "", "", "", "", "", "ǳ", "", "", "", "", "", "Ƚ", "",
	},

	/* 0xd5 */
	{
		"", "", "", "", "", "", "", "", "ǫ", "", "", "", "", "", "", "",
		"ʤ", "", "", "", "", "", "", "", "˻", "", "", "", "", "", "", "",
		"ɦ", "", "̥", "Ͽ", "", "", "", "", "", "", "", "̯", "", "α", "", "",
		"", "", "", "", "", "", "˹", "", "", "", "", "", "", "", "", "",
	},

	/* 0xd6 */
	{
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "ū",
		"", "", "", "", "ͺ", "Ʃ", "˴", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
		"", "", "", "", "", "", "", "", "", "!",  "#",  "$",  "&",  "(",  ")",  "",
	},

	/* 0xd7 */
	{
		"&",  "+",  ",",  "-",  ".",  "/",  "2",  "4",  "5",  "6",  "7",  "8",  "9",  ":",  ";",  "<",
		"=",  ">",  "@",  "Q",  "[",  "\\", "]",  "~",  "_",  "~",  "q",  "w",  "x",  "y",  "z",  "{",
		"|",  "}",  "~",  "",

		/* 楳(0xa40xbc) */
		"\n", ""/*\0*/,   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",

		/* 饯̾򼨤楳(0xd7bd0xd88a) */
		"ƥ", "å", "",
	},

	/* 0xd8 */
	{
		/* 饯̾򼨤楳(0xd7bd0xd88a) */
		"ɥ", "ɥ", "ޥå", "ꥹ", "ȥ饴", "", "åĥ", "⥰",
		"", "", "ޥ",

		/* 楳 */
		"",   "",   "",   "",   "[]",
		"",   "%d", "%s", "%s", "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},

	/* 0xd9 */
	/* 0xda */
	/* 0xdb */
	/* 0xdc */
	{
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},
	{
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},
	{
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},
	{
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
		"",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",   "",
	},
};

static void dec_init(void);

static long tbl_offset_short[NUM_TEXTDATA_SHORT + 1];
static long tbl_offset_long[NUM_TEXTDATA_LONG + 1];
static int flag_setdecode = 0;

static void dec_init(void)
{
	int i;
	unsigned char buf[SIZEOF_OFFSETADDR];

#ifndef NDEBUG
	{
		int i, j;

		for (i = 0; i < (int)(sizeof(tbl_charcode) / sizeof(tbl_charcode[0])); i++)
			for (j = 0; j < 64; j++)
				assert(tbl_charcode[i][j] != NULL);

		for (i = 0; i < (int)(sizeof(tbl_charcode_msg) / sizeof(tbl_charcode_msg[0])); i++)
			for (j = 0; j < 64; j++)
				assert(tbl_charcode_msg[i][j] != NULL);
	}
#endif

	/* ˥塼ѤΥƥȥǡǼƤ륢ɥ쥹(ؤΥեå)ɤ߹ */
	for (i = 0; i < NUM_TEXTDATA_SHORT; i++)
	{
		file_read(buf, FILEPOS_TEXTDATA_SHORT + 0x10 + SIZEOF_OFFSETADDR * i, SIZEOF_OFFSETADDR);
		tbl_offset_short[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}
	/* üեå */
	{
		file_read(buf, FILEPOS_TEXTDATA_SHORT + 0x0c, SIZEOF_OFFSETADDR);
		tbl_offset_short[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}

	/* åѤΥƥȥǡǼƤ륢ɥ쥹(ؤΥեå)ɤ߹ */
	for (i = 0; i < NUM_TEXTDATA_LONG; i++)
	{
		file_read(buf, FILEPOS_TEXTDATA_LONG + 0x10 + SIZEOF_OFFSETADDR * i, SIZEOF_OFFSETADDR);
		tbl_offset_long[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}
	/* üեå */
	{
		file_read(buf, FILEPOS_TEXTDATA_LONG + 0x0c, SIZEOF_OFFSETADDR);
		tbl_offset_long[i] = (buf[3] << 24) | (buf[2] << 16) | (buf[1] << 8) | buf[0];
	}

	flag_setdecode = 1;
}

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize, enum flag_decode flag_decode)
{
	int i;
	const char *(*ptr_tbl_charcode)[64] = (flag_decode & FLAG_LONG) ? tbl_charcode_msg : tbl_charcode;
	const size_t sizeof_tbl_charcode =
		(flag_decode & FLAG_LONG)
			? sizeof(tbl_charcode_msg) / sizeof(tbl_charcode_msg[0])
			: sizeof(tbl_charcode) / sizeof(tbl_charcode[0]);

	/* å */
	if (ptr_dstbuf == NULL || ptr_srcbuf == NULL || dstbufsize == 0 || srcbufsize == 0)
	{
		assert(0);
		return NULL;
	}

	/* ʸǥɤ */
	*ptr_dstbuf = '\0';
	for (i = 0; i < (int)srcbufsize; i++)
	{
		/* ޥХ (bit7  1) */
		if ((ptr_srcbuf[i] & 0x80) != 0x00)
		{
			if ((ptr_srcbuf[i] & 0x3f) < (int)sizeof_tbl_charcode)
			{
				assert(i + 1 < (int)srcbufsize - 1); /* üʸ (-1) ޤǤ뤫 */
				strncat(ptr_dstbuf, ptr_tbl_charcode[ptr_srcbuf[i] & 0x3f][ptr_srcbuf[i + 1] & 0x3f],
						dstbufsize - strlen(ptr_dstbuf) - 1);
			}
			else
				assert(0);

			/* 1 ʸʤ */
			i++;
		}
		/* 󥰥Х */
		else
		{
			/* bit6 ˤäʸɽѤ*/
			strncat(ptr_dstbuf, ptr_tbl_charcode[((ptr_srcbuf[i] & 0x40) != 0x00) ? 1 : 0][ptr_srcbuf[i] & 0x3f],
					dstbufsize - strlen(ptr_dstbuf) - 1);
		}
	}

	return ptr_dstbuf;
}

char *dec_msg(char *ptr_dstbuf, size_t dstbufsize, size_t id, enum flag_decode flag_decode)
{
	const long filepos     = (flag_decode & FLAG_LONG) ? FILEPOS_TEXTDATA_LONG : FILEPOS_TEXTDATA_SHORT;
	const long *tbl_offset = (flag_decode & FLAG_LONG) ? tbl_offset_long : tbl_offset_short;
	const size_t num_msgid = (flag_decode & FLAG_LONG) ? NUM_MSGID_LONG : NUM_MSGID_SHORT;
	unsigned char *buf_srcbuf;
	size_t srcbufsize;

	/* ơ֥ͤꤵƤʤϡͤꤹ */
	if (!flag_setdecode)
		dec_init();

	/* å */
	if (ptr_dstbuf == NULL || dstbufsize == 0 || id >= num_msgid)
	{
		assert(0);
		return NULL;
	}

	/* å ID ºݤΥåǡΰ֤˽ */
	if (flag_decode & FLAG_LONG)
	{
		id *= 2;
		if (flag_decode & FLAG_KANJI)
			id++;
	}

	/* ХåեΥꤹ */
	if (tbl_offset[id + 1] - tbl_offset[id] <= 0)
	{
		assert(0);
		return NULL;
	}
	srcbufsize = tbl_offset[id + 1] - tbl_offset[id];

	/* Хåեݤ */
	if ((buf_srcbuf = malloc(srcbufsize)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ե뤫ʸХåեɤ߹ */
	file_read(buf_srcbuf, filepos + tbl_offset[id], srcbufsize);

	/* ʸǥɤ */
	dec_string(ptr_dstbuf, buf_srcbuf, dstbufsize, srcbufsize, flag_decode);

	free(buf_srcbuf);
	buf_srcbuf = NULL;

	return ptr_dstbuf;
}

int dec_writedata(const char *ptr_filename, size_t region_decode_begin, int len_decode, enum flag_decode flag_decode)
{
	int i;
	FILE *fp = NULL;
	char *ptr;
	char buf[2048] = "";

	if (len_decode == -1)
		len_decode = ((flag_decode & FLAG_LONG) ? NUM_MSGID_LONG : NUM_MSGID_SHORT) - region_decode_begin;

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || len_decode < 0)
	{
		assert(0);
		return 0;
	}

	/* åǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* 󥹥ΥåǡϤ */
	fprintf(fp, "No.         å\n");
	for (i = region_decode_begin; i < (int)region_decode_begin + len_decode; i++)
	{
		/* åǡϤ */
		dec_msg(buf, sizeof(buf), i, flag_decode);

		/* Ԥ򵭹֤ */
		while ((ptr = strrchr(buf, '\n')) != NULL)
			*ptr = '/';

		fprintf(fp, "%04d(%04X): %s\n", i, i, buf);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
