/*
 *	ff6define.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6DEFINE_H)
#define FF6DEFINE_H

enum
{
	ELEM_IDX_FIRE,		/*  */
	ELEM_IDX_ICE,		/* ɹ */
	ELEM_IDX_THUNDER,	/*  */
	ELEM_IDX_POISON,	/*  */
	ELEM_IDX_WIND,		/*  */
	ELEM_IDX_SACRED,	/*  */
	ELEM_IDX_EARTH,		/*  */
	ELEM_IDX_WATER,		/*  */

	NUM_ELEMENT
};

enum
{
	STATE_IDX_DARKNESS,		/* Ű */
	STATE_IDX_ZOMBIE,		/* ӡ */
	STATE_IDX_POISON,		/*  */
	STATE_IDX_MAGITEK,		/* Ƴޡ */
	STATE_IDX_VANISH,		/* Ʃ */
	STATE_IDX_KAPPA,		/* å */
	STATE_IDX_STONE,		/* в */
	STATE_IDX_SWOON,		/* Ʈǽ */

	STATE_IDX_BECOME_DEATH,	/*  */
	STATE_IDX_DEADLY,		/* λ */
	STATE_IDX_ILLUSION,		/* ʬ */
	STATE_IDX_SILENT,		/*  */
	STATE_IDX_BERSERK,		/* С */
	STATE_IDX_CONFUSE,		/*  */
	STATE_IDX_SLIP,			/* å */
	STATE_IDX_SLEEP,		/* ̲ */

	STATE_IDX_FLYING,		/* Ǥ */
	STATE_IDX_REGENERATION,	/* ꥸ */
	STATE_IDX_SLOW,			/*  */
	STATE_IDX_HASTE,		/* إ */
	STATE_IDX_STOP,			/* ȥå */
	STATE_IDX_SHELL,		/*  */
	STATE_IDX_PROTECT,		/* ץƥ */
	STATE_IDX_REFLECT,		/* ե쥯 */

	STATE_IDX_RAGE,			/* Ф */
	STATE_IDX_FREEZING,		/* ɹŤ */
	STATE_IDX_RERAISE,		/* 쥤 */
	STATE_IDX_MORPH,		/* ȥ */
	STATE_IDX_CAST_SPELL,	/* ˡ򾧤Ƥ */
	STATE_IDX_EXIT,			/* Υæ */
	STATE_IDX_INTERCEPTOR,	/* 󥿡ץ */
	STATE_IDX_LEVITATE,		/* ӥƥ */

	NUM_STATE
};

#define ELEM_FIRE		(1U << ELEM_IDX_FIRE)
#define ELEM_ICE		(1U << ELEM_IDX_ICE)
#define ELEM_THUNDER	(1U << ELEM_IDX_THUNDER)
#define ELEM_POISON		(1U << ELEM_IDX_POISON)
#define ELEM_WIND		(1U << ELEM_IDX_WIND)
#define ELEM_SACRED		(1U << ELEM_IDX_SACRED)
#define ELEM_EARTH		(1U << ELEM_IDX_EARTH)
#define ELEM_WATER		(1U << ELEM_IDX_WATER)
#define ELEM_ALL		(ELEM_FIRE	| ELEM_ICE		| ELEM_THUNDER	| ELEM_POISON	| \
						ELEM_WIND	| ELEM_SACRED	| ELEM_EARTH	| ELEM_WATER)

#define STATE_DARKNESS		(1U << STATE_IDX_DARKNESS)
#define STATE_ZOMBIE		(1U << STATE_IDX_ZOMBIE)
#define STATE_POISON		(1U << STATE_IDX_POISON)
#define STATE_MAGITEK		(1U << STATE_IDX_MAGITEK)
#define STATE_VANISH		(1U << STATE_IDX_VANISH)
#define STATE_KAPPA			(1U << STATE_IDX_KAPPA)
#define STATE_STONE			(1U << STATE_IDX_STONE)
#define STATE_SWOON			(1U << STATE_IDX_SWOON)
#define STATE_PERMANENT		(STATE_DARKNESS	| STATE_ZOMBIE	| STATE_POISON	| STATE_MAGITEK	| \
							STATE_VANISH	| STATE_KAPPA	| STATE_STONE	| STATE_SWOON)

#define STATE_BECOME_DEATH	(1U << STATE_IDX_BECOME_DEATH)
#define STATE_DEADLY		(1U << STATE_IDX_DEADLY)
#define STATE_ILLUSION		(1U << STATE_IDX_ILLUSION)
#define STATE_SILENT		(1U << STATE_IDX_SILENT)
#define STATE_BERSERK		(1U << STATE_IDX_BERSERK)
#define STATE_CONFUSE		(1U << STATE_IDX_CONFUSE)
#define STATE_SLIP			(1U << STATE_IDX_SLIP)
#define STATE_SLEEP			(1U << STATE_IDX_SLEEP)
#define STATE_TEMPORARY		(STATE_BECOME_DEATH	| STATE_DEADLY	| STATE_ILLUSION	| STATE_SILENT	| \
							STATE_BERSERK		| STATE_CONFUSE	| STATE_SLIP		| STATE_SLEEP)

#define STATE_FLYING		(1U << STATE_IDX_FLYING)
#define STATE_REGENERATION	(1U << STATE_IDX_REGENERATION)
#define STATE_SLOW			(1U << STATE_IDX_SLOW)
#define STATE_HASTE			(1U << STATE_IDX_HASTE)
#define STATE_STOP			(1U << STATE_IDX_STOP)
#define STATE_SHELL			(1U << STATE_IDX_SHELL)
#define STATE_PROTECT		(1U << STATE_IDX_PROTECT)
#define STATE_REFLECT		(1U << STATE_IDX_REFLECT)
#define STATE_ASSISTMAG		(STATE_FLYING	| STATE_REGENERATION	| STATE_SLOW	| STATE_HASTE	| \
							STATE_STOP		| STATE_SHELL			| STATE_PROTECT	| STATE_REFLECT)

#define STATE_RAGE			(1U << STATE_IDX_RAGE)
#define STATE_FREEZING		(1U << STATE_IDX_FREEZING)
#define STATE_RERAISE		(1U << STATE_IDX_RERAISE)
#define STATE_MORPH			(1U << STATE_IDX_MORPH)
#define STATE_CAST_SPELL	(1U << STATE_IDX_CAST_SPELL)
#define STATE_EXIT			(1U << STATE_IDX_EXIT)
#define STATE_INTERCEPTOR	(1U << STATE_IDX_INTERCEPTOR)
#define STATE_LEVITATE		(1U << STATE_IDX_LEVITATE)
#if 0
#define STATE_OTHER			(STATE_RAGE      | STATE_FREEZING | STATE_RERAISE     | STATE_MORPH | \
							STATE_CAST_SPELL | STATE_EXIT     | STATE_INTERCEPTOR | STATE_LEVITATE)
#else
#define STATE_OTHER			(STATE_FREEZING | STATE_RERAISE | STATE_EXIT | STATE_INTERCEPTOR | STATE_LEVITATE)
#endif /* 0 */

#define STATE_ALL			(STATE_PERMANENT | STATE_TEMPORARY | STATE_ASSISTMAG | STATE_OTHER)

typedef unsigned char elem_t;
typedef unsigned long state_t;

const char *str_getflag(int flag);
const char *str_getelem(elem_t elem, int index);
void str_printelem(FILE *stream, elem_t elem, elem_t elem_mask);
const char *str_getstate(state_t state, int index);
void str_printstate(FILE *stream, state_t state, state_t state_mask);

#define bits_make32(byte1, byte2, byte3, byte4)	(((unsigned long)(byte1) & 0xff) | \
												(((unsigned long)(byte2) & 0xff) <<  8) | \
												(((unsigned long)(byte3) & 0xff) << 16) | \
												(((unsigned long)(byte4) & 0xff) << 24))
#define MAX(a, b)		((a > b) ? (a) : (b))
#define MIN(a, b)		((a < b) ? (a) : (b))

#endif /* FF6DEFINE_H */
