/*
 *	ff6item.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6ITEM_H)
#define FF6ITEM_H

#include "ff6define.h"
#include "ff6magic.h"

enum item_type	/* itemdata_tag.type */
{
	ITEM_TYPE_TOOL,			/*  */
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_ARMOR,		/*  */
	ITEM_TYPE_SHIELD,		/*  */
	ITEM_TYPE_HAT,			/* Ƭ */
	ITEM_TYPE_RELIC,		/*  */
	ITEM_TYPE_ITEM			/* ƥ */
};

typedef struct itemdata_tag
{
	enum item_type type;			/*  */
	int effect_type;				/* ̥ */
	long price;						/*  */
	int attack_defense_power;		/* /ɸ */
	int evade_rate;					/* Ψ */
	int magic_defense_power;		/* ˡɸ */
	int magic_evade_rate;			/* ˡΨ */
	int hit_rate;					/* ҥå */
	int increase_strength;			/* Ͼ徺 */
	int increase_speed;				/* ®徺 */
	int increase_stamina;			/* Ͼ徺 */
	int increase_magic_power;		/* Ͼ徺 */
	int effect_no;					/* ü */
	int learn_magic_no;				/* Ǥˡ */
	int learn_magic_rate;			/* ԡ */
	unsigned char effect_field;
	unsigned int  effect_status;
	unsigned long effect_battle;
	elem_t elem_half;				/* /Ⱦ° */
	elem_t elem_none;				/* ̵° */
	elem_t elem_absorb;				/* ۼ° */
	elem_t elem_double;				/* ° */
	state_t state_defense;			/* Ѳؤ */
	state_t state_apriori;			/* ǽ餫ŬѤѲ */
	state_t state_effect;			/* Ѳ */
	unsigned long bits_equip_chr;	/* ǽ饯 */
	int flag_throw;					/* ꤲ */
	int flag_using_effect;			/* ṳ̈(Ѥ뤳Ȥ)ȯư */
	int flag_additional_effect;		/* ṳ̈(ɲø̤Ȥ)ȯư */
	int flag_runic;					/* ǽ */
	int flag_2handed;				/* ξǽ */
	int flag_backrow;				/* 󤫤ǤϤ㲼ʤ */
	int flag_swordtech;				/* ɬǽ */
	int direction;					/* ȯư(0: ̣¦, 1: Ũ¦) */
	int range;						/* ϰ(0: ñ, 1: ) */
	int change_direction;			/* ȯưѲ(0: , 1: ) */
	int change_range;				/* ϰϤѲ(0: , 1: ) */
	int flag_range_all;				/* ϰϡоݤỤ̃Ρ׸ */
	int col_item_no;				/* ǥƥ򤫤ݤǤ륢ƥ */
	int col_monster_no;				/* ǥƥ򤫤ݤƮ󥹥 */
	int col_flag_erase;				/* ǥƥ򤫤ݤǤ륢ƥ̾ɽʤ */
} itemdata_t;

const char *item_getname(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelem(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestate(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeflag(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writecol(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* FF6ITEM_H */
