/*
 *	ff6misc.c
 *		Copyright (C) 2008 Inu
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "file.h"
#include "ff6misc.h"

#define FILEPOS_TRDATA		0x62b61c	/* SNES: 0x2d8634 */
#define NUM_TREASURE		312
#define SIZEOF_TRDATA		5
#define OFFSET_MONENC		0x100

treasure_t *tr_readdata(void)
{
	int i;
	treasure_t *buf_trdata = NULL;
	unsigned char tbl_treasure_flag[512] = { 0 };

	/* ȢγƼǡǼХåեݤ */
	if ((buf_trdata = malloc(sizeof(treasure_t) * NUM_TREASURE)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* ȢγƼǡɤ߹ */
	for (i = 0; i < NUM_TREASURE; i++)
	{
		unsigned char buf[SIZEOF_TRDATA];

		file_read(buf, FILEPOS_TRDATA + SIZEOF_TRDATA * i, SIZEOF_TRDATA);

		/* ͷϥǡ */
		buf_trdata[i].map.x  = buf[0];
		buf_trdata[i].map.y  = buf[1];
		buf_trdata[i].id     = ((buf[3] & 0x01) != 0x00) ? buf[2] + 0x100 : buf[2];

		/* ȢȤμȽ̤ */
		if ((buf[3] & 0x80) != 0x00)
			buf_trdata[i].type = TREASURE_TYPE_GIL;
		else if ((buf[3] & 0x40) != 0x00)
		{
			buf_trdata[i].param.item_no = ((buf[3] & 0x04) != 0x00) ? 0x100 : 0;

			buf_trdata[i].type = TREASURE_TYPE_ITEM;
		}
		else if ((buf[3] & 0x20) != 0x00)
			buf_trdata[i].type = TREASURE_TYPE_BATTLE;
		else if ((buf[3] & 0x08) != 0x00)
			buf_trdata[i].type = TREASURE_TYPE_EMPTY;
		else
			assert(0);

		/* ȢȤΥǡɤ߹ */
		switch (buf_trdata[i].type)
		{
		case TREASURE_TYPE_ITEM:
			buf_trdata[i].param.item_no += buf[4];
			break;

		case TREASURE_TYPE_GIL:
			buf_trdata[i].param.gil = buf[4] * 100;
			break;

		case TREASURE_TYPE_BATTLE:
			buf_trdata[i].param.battle_no = buf[4] + OFFSET_MONENC;
			break;

		case TREASURE_TYPE_EMPTY:
			break;

		default:
			assert(0);
		}

		tbl_treasure_flag[buf_trdata[i].id] += 1;
	}

	for (i = 0; i < NUM_TREASURE; i++)
	{
		if (tbl_treasure_flag[buf_trdata[i].id] > 1)
			buf_trdata[i].flag_duplicate = 1;
		else
			buf_trdata[i].flag_duplicate = 0;
	}

	return buf_trdata;
}

int tr_writedata(const char *ptr_filename, const treasure_t *ptr_trdata, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty)
{
	int i, j;
	FILE *fp = NULL;
	const char *str_empty = "(å!)";

	/* å */
	if (ptr_filename == NULL || *ptr_filename == '\0' || ptr_trdata == NULL)
	{
		assert(0);
		return 0;
	}

	/* ȢγƼǡϤե򳫤 */
	if ((fp = fopen(ptr_filename, "w")) == NULL)
		return 0;

	/* ȢγƼǡϤ */
	fprintf(fp, "No.        ID   ͭ ʪ\n");
	for (i = 0; i < NUM_TREASURE; i++)
	{
		fprintf(fp, "%03d(%03X): %3d :  %2s  ", i, i, ptr_trdata[i].id, str_getflag(ptr_trdata[i].flag_duplicate));

		switch (ptr_trdata[i].type)
		{
		case TREASURE_TYPE_EMPTY:
			fprintf(fp, "%-16s", str_empty);
			break;

		case TREASURE_TYPE_ITEM:
			fprintf(fp, "%-16s", item_getname(ptr_trdata[i].param.item_no));
			break;

		case TREASURE_TYPE_GIL:
			{
				char str_gil[256] = "";

				snprintf(str_gil, sizeof(str_gil), "%ld", ptr_trdata[i].param.gil);
				fprintf(fp, "%-16s", str_gil);
			}
			break;

		case TREASURE_TYPE_BATTLE:
			{
				const int monenc_no = ptr_trdata[i].param.battle_no;
				int monparty_old = 0;

				fprintf(fp, "[󥹥Ʈ: No.%03d(%03X): ", monenc_no, monenc_no);
				for (j = 0; j < 2; j++)
				{
					const int monparty_no = ptr_monenc[monenc_no].party_no[j];
					int index;
					int found = 0, monster_old = 0;

					if (j != 0 && monparty_no == monparty_old)
						continue;
					else if (j != 0)
						fprintf(fp, " / ");

					for (index = 0; index < 6; index++)
					{
						const int monster_no = ptr_monparty[monparty_no].monster_no[index];
						const int flag_absent = ((ptr_monparty[monparty_no].bits_exist & (1U << index)) == 0x00);

						if (!flag_absent && (found == 0 || monster_no != monster_old))
						{
							if (found++)
								fprintf(fp, ", ");

							fprintf(fp, "%s", mon_getname(monster_no));
							monster_old = monster_no;
						}
					}

					monparty_old = monparty_no;
				}
				fprintf(fp, "]");
			}
			break;

		default:
			assert(0);
		}

		fputc('\n', fp);
	}

	fclose(fp);
	fp = NULL;

	return 1;
}
