/*
 *	ff6monster.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 *		Copyright (C) 2008 Inu
 */

#if !defined(FF6MONSTER_H)
#define FF6MONSTER_H

#include "ff6define.h"
#include "ff6item.h"
#include "ff6magic.h"
#include "ff6map.h"

typedef struct mondata_tag
{
	int level;					/* ٥ */
	long hit_point;				/* ҥåȥݥ */
	long magic_point;			/* ޥåݥ */
	long experience_point;		/* и */
	long gil;					/*  */
	int speed;					/* ® */
	int attack_power;			/*  */
	int defense_power;			/* ɸ */
	int evade_rate;				/* Ψ */
	int magic_attack_power;		/* ˡ */
	int magic_defense_power;	/* ˡɸ */
	int magic_evade_rate;		/* ˡΨ */
	int hit_rate;				/* ҥå */
	int item_metamorph;			/* ƥѲ */
	int weapon_no;				/* ̾ﹶ */
	int stamina;				/*  */
	elem_t elem_none;			/* ̵° */
	elem_t elem_absorb;			/* ۼ° */
	elem_t elem_double;			/* ° */
	state_t state_defense;		/* Ѳؤ */
	state_t state_apriori;		/* ǽ餫ŬѤѲ */
	int flag_suplex;			/* ꤲǽ */
	int flag_control;			/* ֤Ĥפǽ */
	int flag_scan;				/* ֥饤֥פǽ */
	int flag_sketch;			/* ֥åפǽ */
	int flag_initiative;		/* ǽ˹ưǤ */
	int flag_undead;			/* ǥåɷϤǤ */
	int flag_imp;				/* åѾ֤ǥƥҥå */
	int flag_human;				/* ʹַϤǤ */
	int flag_mp0;				/* ޥåݥȤ0ˤݤ */
	int flag_erase_name;		/* ̾ɽʤ */
	int flag_escape;			/* ƨǽǤ */
	int flag_escape_h;			/* ƨˤ */
	int item_no[4];				/* ƥ */
	int ragna_item_no[4];		/* Ѳƥ */
	int control_no[4];			/* ֤Ĥפιư */
	int sketch_no[2];			/* ֥åפιư */
	int rage_no[2];				/* ֤Фפιư */
	int tech_weapon_no;			/* ü칶 */
	int tech_flag_damage;		/* ü칶⤬᡼ȼ */
	int tech_flag_ignore_evade;	/* ü칶⤬Ψ̵뤹 */
	int tech_type;				/* ü칶μ */
} mondata_t;

typedef struct monact_tag
{
	int ptn_num;
	struct
	{
		size_t action_size;		/* ưѥǡΥХȿ */
		unsigned char *action;	/* ưѥǡ */
	} ptn[32];
} monact_t;

typedef struct monparty_tag
{
	int monster_no[6];			/* 󥹥μ */
	int magic_learning_gain;	/* ˡ */
	unsigned int bits_exist;	/* Ʈϻ˥󥹥иƤ뤫 */
	unsigned char bits_vfx;		/* и */	
	int flag_normal;			/* ̾Ʈβǽ */
	int flag_backattack;		/* Хååβǽ */
	int flag_pincer;			/* Ϥߤβǽ */
	int flag_sideattack;		/* ɥåβǽ */
	int flag_beastfield;		/* å˽и뤫ɤ() */
} monparty_t;

typedef struct monenc_tag
{
	int party_no[4];	/* 󥹥ѡƥμ */
} monenc_t;

typedef struct monmap_tag
{
	struct
	{
		int enc_no[4];
	} area[8][8];
} monmap_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monact_t *mon_readact(void);
monparty_t *mon_readparty(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeelem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writestate(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeragna(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writectrl(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writesketch(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writerage(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writetech(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const monact_t *ptr_monact, const mondata_t *ptr_mondata);
int mon_writemes(const char *ptr_filename);
int mon_writeevent(const char *ptr_filename);
int mon_writeparty(const char *ptr_filename, const monparty_t *ptr_monparty);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);
int mon_writelocation(const char *ptr_filename, const mapdata_t *ptr_mapdata, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);
int mon_writeveldt(const char *ptr_filename, const monparty_t *ptr_monparty);
void mon_printparty(FILE *stream, const monparty_t *ptr_monparty);
void mon_freeact(monact_t *ptr_monact);

#endif /* FF6MONSTER_H */
